#!csh

set bin = "../bin"
setenv AR_DATA .
setenv DOMAIN .
setenv gamma 1


if ($1 == "") then
 echo "ERROR\!\!\!\!: Specify the Directory of the experiment (e.g. SK for CKB.SK)"
 exit
endif

set KB = ../CKB.$1

if (-d $1) then
 echo "ERROR\!\!\!\!: experiments already present remove it please and re-try"
 exit
endif

if (!(-d ./CKB.$1)) then
 echo "ERROR\!\!\!\!: could not find CKB.$1 Knowledgebase"
 exit
endif

mkdir $1
mkdir $1/dat
cd $1

if ($2 != "SK") then
   echo "No SEMANTIC KERNEL features (to add them <crtl> <c> and add 'SK')"
   set training = $KB/splitClasses
   set testing = $KB/testdoc
else
   echo "Learning Files include SEMANTIC KERNEL"
   set training = $KB/PT_training/
   set testing = $KB/PT_testing/
endif

echo "Take learning file from $KB and test documents from <../CKB/testdoc> dir."

cat $training/*.le | sort -u > training.temp
$bin/mysort_merge training.temp > training

if($3 == "weighting") then
	echo "***" weighting features "***"
	echo
    $bin/weightInstances CLU -DI$KB -SC. -OC. -IC. -NC. -VERB -LE -W -D  ALL 
else 
    $bin/weightInstances CLU -DI$KB -SC. -OC. -IC. -NC. -VERB -LE -D ALL 
endif

mv SVM_trainingFile SVM_training

if(-f test.temp) rm test.temp
endif
echo
echo

cat $testing/*.le  >> test.temp

sort -u test.temp > test2.temp

$bin/mysort_merge test2.temp > training


if($3 == "weighting") then
	echo "***" Weighting features "***"
        echo
	$bin/weightInstances CLU -DI$KB -SC. -OC. -IC. -NC. -VERB -LE  -W -D ALL 
else 
    	$bin/weightInstances CLU -DI$KB -SC. -OC. -IC. -NC. -VERB -LE -D ALL 
endif


mv SVM_trainingFile SVM_testing


# GENERATE class learning files

$bin/change_format SVM_training $KB/oracle train
$bin/change_format SVM_testing  $KB/oracle test

#rm *.temp
