/***********************************************************************/
/*   Text Categorization Framework                                     */
/*                                                                     */
/*                                                                     */
/*   Author: Alessandro Moschitti                                      */
/*   moschitti@info.uniroma2.it                                        */
/*   Date: 30.11.03                                                    */
/*                                                                     */
/*   Copyright (c) 2003  Alessandro Moschitti - All rights reserved    */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/



#include "classifier.h"
#include <string.h>
writeCouples(char *p, char dati[],int n)
{
 int i;
 for(i=0;i<n;i++)
 {
  dati[i]=*p;
  p++;
 }
}


readCouples(char *p, char dati[],int n)
{
 int i;
 for(i=0;i<n;i++)
 {
  *p=dati[i];
  p++;
 }
}


int Search(struct dictionaryOffset Dict[],char term[],int i, int j)
{
/* if(strcmp("'---'-A",term)==0)printf("i:%d   j:%d\n");*/
 if(i>j)return -1;
   else
    if(strcmp(Dict[i+(j-i)/2].term,term)==0) return i+(j-i)/2;
      else 
       if(strcmp(Dict[i+(j-i)/2].term,term)<0)
       	 return Search(Dict,term,i+(j-i)/2+1,j);
       else
       	 return Search(Dict,term,i,i+(j-i)/2-1);
 } 
      	 
 
 /* Load Dictionary OffSet in memory */

 void loadDictionaryOffset(FILE *f2, int *differentWordNumber, struct dictionaryOffset **Dict)
 {
  char term[TERM_LENGHT];
  int offset;
  int i=0;
  /*differentWordNumber-=2;*/
  *Dict = (struct dictionaryOffset *)malloc(
		  sizeof(struct dictionaryOffset)*(*differentWordNumber));
   printf("\nExpected number of words: %d\n\n",*differentWordNumber);
    fseek(f2,0L,SEEK_SET);  
   while (!feof(f2)) { 
   	
	  
    if (fscanf(f2,"%s",term)!=1)
	    { printf(" WARNING : unreadable 'Term' in Dictionary file\n"); 
    	      printf(" 		 'Term' has been replaced with '###' \n");
    	      strcpy(term,"###");}
    if (fscanf(f2,"%d\n",&((*Dict)[i].Offset))!=1)
	    { printf(" WARNING : unreadable 'Offset' in Dictionary file\n");
    	      printf(" 		 it has been set to  0 \n");
	      (*Dict)[i].Offset=0;
	     }
    (*Dict)[i].term=(char *)strdup(term);
    i++ ;
  }
  fscanf(f2,"%s",term);
  if(*differentWordNumber>i){ printf(" warning : more word in globalcentroid than in Dictionary offset\n");}
  if(*differentWordNumber<i){
	    printf(" WARNING : more word in Dictionary offset than in globalcentroid\n");
	    printf("   Last term %s : offset %d\n",(*Dict)[i-1].term,(*Dict)[i-1].Offset);
  } 
  printf("Words loaded: %d \n\n",i);
  *differentWordNumber=i;
  
}


/* Load Dictionary OffSet in memory */

 int loadStopList(char *SLFileName,char *stopList[], short verbose)
 {
     char term[TERM_LENGHT];
     int i=0;
     FILE *SLFILE;

     if((SLFILE=fopen(SLFileName,"r"))==NULL) {
      if (verbose==ON)
	      printf("   Warning : file %s not found (Stop Word List)\n",SLFileName);
	 return 0;
     }
     if (fscanf(SLFILE,"%s",term)!=1)
	       { printf(" ERROR : unreadable 'Term' in Stop Word file\n"); exit(-1); }

     while(!feof(SLFILE)){
      /* if(term[strlen(term)-3]=='-')term[strlen(term)-3]='\0';*/
       stopList[i]=(char *)strdup(term);
       fscanf(SLFILE,"%s",term);
	/*       { printf(" ERROR : unreadable 'Term' in Dictionary file\n"); exit(-1); }*/
       i++;     
    }
     return i;
 }
 
 /* It can be changed in a procedurer that reads onlly the first part of the
 oracle (i.e. the doc id)*/
 int loadDocIDList(char *SLFileName,char *list[], short verbose)
 {
     char term[TERM_LENGHT];
     int i=0;
     FILE *SLFILE;

     if((SLFILE=fopen(SLFileName,"r"))==NULL) {
      if (verbose==ON)
	      printf("   Warning : file %s not found (ID doc List)\n",SLFileName);
	 return 0;
     }
     if (fscanf(SLFILE,"%s",term)!=1)
	       { printf(" ERROR : unreadable 'ID' in Stop Word file\n"); exit(-1); }

     while(!feof(SLFILE)){
      /* if(term[strlen(term)-3]=='-')term[strlen(term)-3]='\0';*/
       list[i]=(char *)strdup(term);
       fscanf(SLFILE,"%s",term);
	/*       { printf(" ERROR : unreadable 'ID' in Dictionary file\n"); exit(-1); }*/
       i++;     
    }
     return i;
 }

 
int SearchInStopList(char *stopWord[],char *term,int i, int j)
{
// if(strstr(term,"_o")==NULL)return 1;
//  else return -1;
 if(i>j)return -1;
   else
    if(strcmp((char *)stopWord[i+(j-i)/2],term)==0) return i+(j-i)/2;
      else 
       if(strcmp((char *)stopWord[i+(j-i)/2],term)<0)
       	 return SearchInStopList(stopWord,term,i+(j-i)/2+1,j);
       else
       	 return SearchInStopList(stopWord,term,i,i+(j-i)/2-1);
 }  
 
/* Read couples */

int couplesRelativeToTerm(FILE *weightDictFile,char *term,struct couples *setOfCouples, struct dictionaryOffset Dict[],int n)
  {
   int orderNumber,
       numberOfCouples,
       Offset,
       j;
   
   char dati[FWRITE_BUFFER_SIZE];
   
   
    orderNumber=Search(Dict,term,0,n-1);
   /* TEST printf("%s trovato nella posizione %d\n\n",term,orderNumber);*/
   
    if(orderNumber>=0)
    {
      Offset=Dict[orderNumber].Offset;
      fseek(weightDictFile,Offset,SEEK_SET);
      
         
    /* TEST printf("dname %s, ordern %d, offsetC %d, term %s, freq %d, ttn%d, gcf %d\n",documentName,
      orderNumber,OffSetC,term,atoi(freq),totalTermNumber,atoi(GLOBAL_CENTROIDFreq));
      */   
      
      /* read the number of couples */
      numberOfCouples=getw(weightDictFile);
      
      setOfCouples->numOfDocWithCurrentTerm=getw(weightDictFile);
      
      /* read each couple*/
      for(j=0;j<numberOfCouples;j++)
       {
        fread(dati,sizeof(struct couple),1,weightDictFile);
        readCouples((char *)&(setOfCouples->couple[j]),dati,sizeof(struct couple));	     
       } 
     return numberOfCouples;
     }
     else return 0;
  }       
 
void shutdownDictionary(struct dictionaryOffset *Dict, int differentWordNumber){
  int i;
  	
  for(i=0;i<differentWordNumber;i++)
	  MYfree(Dict[i].term);
  
  MYfree(Dict);
  
}  

void shutdownStopList(char *stopList[], int numOfStopWord){
  int i;
  	
  for(i=0;i<numOfStopWord;i++)
	  MYfree(stopList[i]);
    
}       
