/***********************************************************************/
/*   Text Categorization Framework                                     */
/*                                                                     */
/*                                                                     */
/*   Author: Alessandro Moschitti                                      */
/*   moschitti@info.uniroma2.it                                        */
/*   Date: 30.11.03                                                    */
/*                                                                     */
/*   Copyright (c) 2003  Alessandro Moschitti - All rights reserved    */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/


#include "classifier.h"
#include <math.h>
#include <string.h>

main(int argc,char **argv){

  FILE *offsetDictFile;
  FILE *weightDictFile;
   char term[TERM_LENGHT];
   long offset;
   int numberOfCouples;
   int j,i,cat;
   char dati[FWRITE_BUFFER_SIZE];
   
   struct couple setOfCouples[MAX_CLASS_NUMBER];
   
  if(argc==1)cat=0;
  else cat=atoi(argv[1]);
  
  if((weightDictFile = fopen("Dict.Weight.le","r"))==NULL) {
      printf("file %s does not found\n","Dict.Weight.le");
      return 0;
  }
  
  if((offsetDictFile = fopen("Dict.Offset.le","r"))==NULL) {
      printf("file %s does not found\n","Dict.Offset.le");
      return 0;
  }
      fscanf(offsetDictFile,"%s",term);
  while(!feof(offsetDictFile)){
	printf("%25s:\t",term);
	fscanf(offsetDictFile,"%s\n",term);
	offset=atoi(term);
	/*printf("offset=%d\n",offset);*/
	fseek(weightDictFile,offset,SEEK_SET);
	/* read the number of couples */
        numberOfCouples=getw(weightDictFile);
     	/*printf("number of couple %d\n",numberOfCouples);*/
      
       /* printf("global freq %d\n",getw(weightDictFile));*/
	getw(weightDictFile);
      
      /* read each couple*/
      for(j=0;j<numberOfCouples;j++){
        fread(dati,sizeof(struct couple),1,weightDictFile);
        readCouples((char *)(&setOfCouples[j]),dati,sizeof(struct couple));	     
       	
	if(setOfCouples[j].centroidNumber==cat)printf("%2.7f",setOfCouples[j].weight);   
	if(setOfCouples[j].weight<0)printf("\n\n\n\nERROR!!!!\n\n\n");
       } 
        printf("0\n");
	fscanf(offsetDictFile,"%s",term);
  }
  fclose(offsetDictFile);
  fclose(weightDictFile);
}  


readCouples(char *p, char dati[],int n)
{
 int i;
 for(i=0;i<n;i++)
 {
  *p=dati[i];
  p++;
 }
}
