/***********************************************************************/
/*   Text Categorization Framework                                     */
/*                                                                     */
/*                                                                     */
/*   Author: Alessandro Moschitti                                      */
/*   moschitti@info.uniroma2.it                                        */
/*   Date: 30.11.03                                                    */
/*                                                                     */
/*   Copyright (c) 2003  Alessandro Moschitti - All rights reserved    */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_LINE_LEN 10000
#define MAX_FILE_LINE_NO 200000

int col2=0;

long partition(char **vect,long part_low, long part_high) {
	
	long lastsmall;
	long comp1;
	long i;
	char *median_val,*transit;

	// swap median value an first value of array
	comp1=(part_low+part_high) / 2;		
	transit=vect[part_low];
	vect[part_low]=vect[comp1];
	vect[comp1]=transit;
	median_val=vect[part_low];
	lastsmall=part_low;
	for (i=part_low+1; i<=part_high; i++) {
		if (strcmp(vect[i]+col2,median_val+col2)<0) {
			lastsmall++;
			// swap lastsmall and i
			transit=vect[lastsmall];
			vect[lastsmall]=vect[i];
			vect[i]=transit;
		}
	}
	// swap part_low and lastsmall
	transit=vect[part_low];
	vect[part_low]=vect[lastsmall];
	vect[lastsmall]=transit;

	return lastsmall;
}

void quicksort(char **vect,long qk_low, long qk_high) {
	if (qk_low < qk_high)	{
		long median=partition(vect,qk_low, qk_high);
		quicksort(vect,qk_low, median);
		quicksort(vect,median+1, qk_high);
	}
}


void PrintUsage(char *ProgramName)
{
    printf("\n %s usage :\n",ProgramName);
    printf("    %s SourceFile > DestinationFile\n",ProgramName);
    printf("   or\n");
	printf("    %s SourceFile > DestinationFile\n",ProgramName);

}

main(long argc,char *argv[]) { 

	FILE *fp;
	char line[MAX_LINE_LEN];
	char firstColum[MAX_LINE_LEN];

	long howmany;
	long i,lineNum=0;


	if ((fp=fopen(argv[1],"r"))==NULL) {
		printf("Source file not accessible\n");
		exit(-1);
	}


	while( fgets( line, MAX_LINE_LEN, fp ) != NULL)lineNum++;
	//printf("NUMBER OF LINES %d\n",lineNum);

        char **vect=(char**)malloc(sizeof(char*)*lineNum);

	if(vect==NULL){printf("\n\nERROR: OUT OF MEMORY\n\n");exit(-1);}
	/* Help request  
	if ( argc<!=2) {
		PrintUsage(argv[0]);
		exit(0);
	}
	
*/

	fseek(fp,0,SEEK_SET);

	if(argc==3)col2 = atoi(argv[2]);
	

	howmany=0;
	while (!feof(fp)) {
			if( fgets( line, MAX_LINE_LEN, fp ) == NULL)  {
			if (!feof(fp))  {
				printf("Error in reading a line\n");
				exit(-1);
			}
		} else
			if((vect[howmany++]=strdup(line))==NULL){
				printf("\n\nERROR: OUT OF MEMORY\n\n");
				exit(-1);
			}
	}
			
	quicksort(vect,0,howmany-1);

	for (i=0; i< howmany ; i++){
		printf("%s",vect[i]);
		free(vect[i]);
	}
	free(vect);
	exit(0);
}

	
