/***********************************************************************/
/*   Text Categorization Framework                                     */
/*                                                                     */
/*                                                                     */
/*   Author: Alessandro Moschitti                                      */
/*   moschitti@info.uniroma2.it                                        */
/*   Date: 30.11.03                                                    */
/*                                                                     */
/*   Copyright (c) 2003  Alessandro Moschitti - All rights reserved    */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/


#include <string.h>
#include <stdio.h>

#define  MAX_CLASS_NUMBER 1000
#define  NAME_LENGTH 100

main(int argc,char **argv){

  FILE *oracle;
  FILE *input;
  
  char catName[NAME_LENGTH],
       catFileName[NAME_LENGTH],
       numdocString[NAME_LENGTH],
       numdocStringFinal[NAME_LENGTH],
       numb[NAME_LENGTH],
       c0,c1,c2;
  int 
      i,
      categoryCount,
      numdoc;
      
  struct {
  	  FILE *categoryFile;
	  char categoryName[NAME_LENGTH];
	  } setOfCat[MAX_CLASS_NUMBER];

  if((input = fopen(argv[1],"r"))==NULL) {
      printf("file %s does not found\n","Dict.Weight.le");
      return 0;
  }
  
  if((oracle = fopen("oracle","w"))==NULL) {
      printf("Cannot write oracle file\n");
      return 0;
  }
  c0='\n';
  c1=getc(input);
  c2=getc(input);
  numdoc=0;categoryCount=0;
  while(!feof(input)){
       if(c1=='.' && c0=='\n' && c2=='I') 
         {
	    fscanf(input,"%s\n",catName); /* read number of doc*/
            fscanf(input,"%s\n",catName); /* read .C*/
	    /* READ categories which the document belong to*/ 	 
	    fscanf(input,"%s",catName);
	    for(i=0;i<categoryCount;i++) fclose(setOfCat[i].categoryFile);
	    categoryCount=0; 
	    while(!feof(input) && strcmp(catName,".T")!=0){

	         fscanf(input,"%s",numb);/* read the number that follows the name */
		 //printf(" catNAME %s \n",catName);
		 //printf(" num %s \n",numb); 
		 
		 for(i=0;i<categoryCount;i++)
		    if(strcmp(catName,setOfCat[i].categoryName)==0)i=categoryCount+3;
		 
		 if(i!=categoryCount+4){
		 
		   sprintf(catFileName,"%s.txt",catName);
		     if((setOfCat[categoryCount].categoryFile = fopen(catFileName,"a"))==NULL) {
      			  printf("Cannot write the %d_th category file\n",i);
      			  return 0;
  			  }
		   strcpy(setOfCat[categoryCount].categoryName,catName);
		   categoryCount++;
		 }
		 
		 fscanf(input,"%s",catName);
	   }
	   
	  sprintf(numdocString,"%d",numdoc);
	  strcpy(numdocStringFinal,"");
	  for(i=strlen(numdocString);i<7;i++)strcat(numdocStringFinal,"0");

	  for(i=0;i<categoryCount;i++)fprintf(oracle,"%s%d\t%s\n",numdocStringFinal,numdoc,setOfCat[i].categoryName);
	  for(i=0;i<categoryCount;i++)fprintf(setOfCat[i].categoryFile,"###%s%d\n",numdocStringFinal,numdoc); 
	  numdoc++;
	  c0='\n';c1=getc(input);c2=getc(input);
	 }	 
         else {
	 	if(c1=='.' && c0=='\n' && c2=='W'){c0==getc(input);c1=getc(input);c2=getc(input);}
		else{
		     for(i=0;i<categoryCount;i++)putc(c0,setOfCat[i].categoryFile);
		     c0=c1;
		     c1=c2;
		     c2=getc(input);
	        }
	  }
  }
  for(i=0;i<categoryCount;i++){
  	putc(c1,setOfCat[i].categoryFile);
	putc(c2,setOfCat[i].categoryFile);
  	fclose(setOfCat[i].categoryFile);
  }

}  
