/***********************************************************************/
/*   Text Categorization Framework                                     */
/*                                                                     */
/*                                                                     */
/*   Author: Alessandro Moschitti                                      */
/*   moschitti@info.uniroma2.it                                        */
/*   Date: 30.11.03                                                    */
/*                                                                     */
/*   Copyright (c) 2003  Alessandro Moschitti - All rights reserved    */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/


#include "classifier.h"
#include <math.h>
#include <string.h>
#include <stdlib.h>

#define SAMPLE_MAX 100
#define GAMMA_MAX 100

int main(int argc, char** argv){
  
   int i,
       classNumber,
       NumberOfClasses=0,
       SAMPLE_NUM,
       gamma,
       lastGamma;
       
   float		   
	threshold[MAX_CLASS_NUMBER],
	sum_gamma[MAX_CLASS_NUMBER],
	sum_BEP[MAX_CLASS_NUMBER],
	sum_threshold[MAX_CLASS_NUMBER],
	matrixThres[MAX_CLASS_NUMBER][GAMMA_MAX][SAMPLE_MAX],
	matrixGamma[MAX_CLASS_NUMBER][SAMPLE_MAX],
	
	RP_Difference,
	current_gamma,
	gamma_avg,
	threshAvg=0,
	BEP_avg;	

   char thres_string[PATH_LENGHT];
   char gamma_string[PATH_LENGHT];
   char BEP_string[PATH_LENGHT];
   char thresholdName[PATH_LENGHT];
   char ignoreString[PATH_LENGHT];

   FILE *thresholdFile,*gammaFile;
   
   
  /* -------------------------------------------- */
  /*   	Load Thresholds and gammaFile		  */
  /* -------------------------------------------- */

NumberOfClasses=0;
for(classNumber=0;classNumber<MAX_CLASS_NUMBER;classNumber++)
	sum_threshold[classNumber]=sum_gamma[classNumber]= sum_BEP[classNumber]=0;

  gamma=SAMPLE_NUM=0;
  
  sprintf(thresholdName,"%s.%d.%d",argv[1],gamma,SAMPLE_NUM);
  thresholdFile = fopen(thresholdName,"r");
     while(thresholdFile!=NULL){
	classNumber=0;
	printf("\nLoading a threshold for each category wrt the couple <gamma,sample>: <%s> file\n",
	thresholdName);
	
	/* the first field of thresholds files is the BEP threshold of last test-set evaluation (i.e. related to the last gamma)*/
	/* the second is the threshold of the best gamma tried til now */
	/* the third and forth are the best gamma and the performance associated to it */

	while(!feof(thresholdFile)){
		fscanf(thresholdFile,"%s\t%s\t%s\t%s\n",thres_string,ignoreString,gamma_string,BEP_string);
		matrixThres[classNumber][gamma][SAMPLE_NUM]=atof(thres_string);
		/* TEST printf("%d)%f\t%f\t%f\n",classNumber,
			atof(thres_string),
			atof(gamma_string),
			atof(BEP_string));*/
		classNumber++;
        }
       fclose(thresholdFile);
       gamma++;
       sprintf(thresholdName,"%s.%d.%d",argv[1],gamma,SAMPLE_NUM);
       if((thresholdFile = fopen(thresholdName,"r"))==NULL){
       	  lastGamma=gamma-1;
	  gamma=0;
       	  SAMPLE_NUM++;
	  sprintf(thresholdName,"%s.%d.%d",argv[1],gamma,SAMPLE_NUM);
	  thresholdFile = fopen(thresholdName,"r");
	}
     }
      
 SAMPLE_NUM=0;
 sprintf(thresholdName,"%s.%d.%d",argv[1],lastGamma,SAMPLE_NUM);
 NumberOfClasses=0;

 while((thresholdFile = fopen(thresholdName,"r"))!=NULL){
	classNumber=0;
	printf("\nLoading optimal gammas for each category <%s> file and for each sample %d\n",
	thresholdName,SAMPLE_NUM);
	while(!feof(thresholdFile)){
		fscanf(thresholdFile,"%s\t%s\t%s\t%s\n",ignoreString,thres_string,gamma_string,BEP_string);
		sum_gamma[classNumber]+=atof(gamma_string);
		sum_BEP[classNumber]+=atof(BEP_string);
/*		matrixGamma[classNumber][SAMPLE_NUM]=atof(gamma_string);
		 TEST printf("%d)%f\t%f\t%f\n",classNumber,
			atof(thres_string),
			atof(gamma_string),
			atof(BEP_string));*/
		classNumber++;
		if(SAMPLE_NUM==0)NumberOfClasses++;
       }
       fclose(thresholdFile);
       SAMPLE_NUM++;
       sprintf(thresholdName,"%s.%d.%d",argv[1],lastGamma,SAMPLE_NUM);
 }
 


  if((thresholdFile = fopen("thresholds","w"))==NULL){
	   printf("ERROR: Cannot write average file\n");
	   exit(-1);
  } 
  
  if((gammaFile = fopen("gammaFileVector_medio","w"))==NULL){
	   printf("cannot write gamma file\n");
	   exit(-1); 
   } 

  for(classNumber=0;classNumber<NumberOfClasses;classNumber++){
		
	BEP_avg=sum_BEP[classNumber]/SAMPLE_NUM;

	gamma_avg=(int)(sum_gamma[classNumber]/SAMPLE_NUM+.5);
	threshAvg=0;
	for(i=0;i<SAMPLE_NUM;i++){
		// TEST printf("%f\n",matrixThres[classNumber][(int)gamma_avg][i]);
		threshAvg += matrixThres[classNumber][(int)gamma_avg][i];
	}
	// TEST printf("\n\n\n");
		
	threshAvg /= SAMPLE_NUM;
		
	fprintf(thresholdFile,"%d\t%f\t%f\t%f\n",-1,threshAvg,gamma_avg,BEP_avg);
	fprintf(gammaFile,"%f\n",gamma_avg);
    }    	 
 
   fclose(thresholdFile);
   fclose(gammaFile);

}
