/***********************************************************************/
/*   Text Categorization Framework                                     */
/*                                                                     */
/*                                                                     */
/*   Author: Alessandro Moschitti                                      */
/*   moschitti@info.uniroma2.it                                        */
/*   Date: 30.11.03                                                    */
/*                                                                     */
/*   Copyright (c) 2003  Alessandro Moschitti - All rights reserved    */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/


#include "classifier.h"
#include <math.h>
#include <string.h>
#include <stdlib.h>


int main(int argc, char** argv) 
  {
   int i,
       classNumber,
       NumberOfClasses,
       SAMPLE_NUM=0;
   float		   
	threshold[MAX_CLASS_NUMBER],
	sum_gamma[MAX_CLASS_NUMBER],
	sum_BEP[MAX_CLASS_NUMBER],
	sum_threshold[MAX_CLASS_NUMBER],
	matrixThres[MAX_CLASS_NUMBER][SAMPLE_NUM],
	matrixGamma[MAX_CLASS_NUMBER][SAMPLE_NUM],
	sumGam[MAX_CLASS_NUMBER],
	freq[MAX_CLASS_NUMBER];
	
     		
   float RP_Difference,
	 current_gamma,
	 gamma_avg,
	 threshsum_avg,
	 BEP_avg;	
  
   float
	 MagThreshold[MAX_CLASS_NUMBER],
	 MinThreshold[MAX_CLASS_NUMBER];


   char thres_string[PATH_LENGHT];
   char gamma_string[PATH_LENGHT];
   char BEP_string[PATH_LENGHT];
   char thresholdName[PATH_LENGHT];

   FILE *thresholdFile,*gammaFile;
   
   
  /* -------------------------------------------- */
  /*   	Load Thresholds and gammaFile		  	  */
  /* -------------------------------------------- */

NumberOfClasses=0;
for(classNumber=0;classNumber<MAX_CLASS_NUMBER;classNumber++)
	sum_threshold[classNumber]=sum_gamma[classNumber]= sum_BEP[classNumber]=0;

  SAMPLE_NUM=0;
  sprintf(thresholdName,"%s%d",argv[1],SAMPLE_NUM);
  
  while((thresholdFile = fopen(thresholdName,"r"))!=NULL){
	classNumber=0;
	printf("\nLoading thresholds, gammas and performances from <%s> file\n",
	thresholdName);
	while(!feof(thresholdFile)){
		fscanf(thresholdFile,"%s\t%s\t%s\n",thres_string,gamma_string,BEP_string);
	   	sum_threshold[classNumber]+=atof(thres_string);
		sum_gamma[classNumber]+=atof(gamma_string);
		sum_BEP[classNumber]+=atof(BEP_string);
	        matrixThres[classNumber][SAMPLE_NUM]=atof(thres_string);
		matrixGamma[classNumber][SAMPLE_NUM]=atof(gamma_string);
		/* TEST printf("%d)%f\t%f\t%f\n",classNumber,
			atof(thres_string),
			atof(gamma_string),
			atof(BEP_string));*/
		classNumber++;
		if(SAMPLE_NUM==0)NumberOfClasses++;
       }
       fclose(thresholdFile);
       SAMPLE_NUM++;
       sprintf(thresholdName,"%s%d",argv[1],SAMPLE_NUM);
 }
 

/*for(classNumber=0;classNumber<NumberOfClasses;classNumber++)sumGam[classNumber]=freq[classNumber]=0;

   for(classNumber=0;classNumber<NumberOfClasses;classNumber++){
	printf("\n\n-----------------------------------------------\n\n%f\n",sum_gamma[classNumber]);
	for(index=0;index<SAMPLE_NUM;index++)
	if(sum_threshold[classNumber]>20){
		sumGam[classNumber]=sum_gamma[classNumber];
		freq[classNumber]=1;
	}else{
	if(matrixGamma[classNumber][index]>-1
	   && matrixGamma[classNumber][index]<31){
		sumGam[classNumber]+=matrixGamma[classNumber][index];
		freq[classNumber]++;
		printf("%f\t",matrixGamma[classNumber][index]);
	}}
  }*/


  if(strcmp(argv[1],"thresholds")==0){
      if((thresholdFile = fopen("thresholds","w"))==NULL){
	   printf("ERROR: Cannot write average file\n");
	   exit(-1);
      } 
  }
 else
   if((gammaFile = fopen("gammaFileVector_medio","w"))==NULL){
	   printf("cannot write gamma file\n");
	   exit(-1); 
   } 

  for(classNumber=0;classNumber<NumberOfClasses;classNumber++){
		
		BEP_avg=sum_BEP[classNumber]/SAMPLE_NUM;

	        gamma_avg=sum_gamma[classNumber]/SAMPLE_NUM;
		
		threshsum_avg=sum_threshold[classNumber]/SAMPLE_NUM;

		if(strcmp(argv[1],"thresholds")==0)
			fprintf(thresholdFile,"%f\t%f\t%f\n",threshsum_avg,gamma_avg,BEP_avg);
		else
			fprintf(gammaFile,"%f\n",gamma_avg);
    }    	 
 
   if(strcmp(argv[1],"thresholds")==0) fclose(thresholdFile);
	else   fclose(gammaFile);

}

