/***********************************************************************/
/*   Text Categorization Framework                                     */
/*                                                                     */
/*                                                                     */
/*   Author: Alessandro Moschitti                                      */
/*   moschitti@info.uniroma2.it                                        */
/*   Date: 30.11.03                                                    */
/*                                                                     */
/*   Copyright (c) 2003  Alessandro Moschitti - All rights reserved    */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/



#include "classifier.h"
#include <math.h>

void documentNormaComputation(struct classFiles class[],int classNumber,
		struct dictionaryOffset *globalCe, int numOfDoc, int differentTermNumber)
{
  int whichClass,
      freq,
      docID,
      termPos,
      i,
      docSize;
  
  char 
	documentId[TERM_LENGHT],
	documentIdOld[TERM_LENGHT],
      	term[TERM_LENGHT];
    
  float	IDF,tfi;
  
  for(whichClass=0;whichClass<classNumber;whichClass++){
    
     fscanf(class[whichClass].file,"%s",documentId);
     
     /*TEST*/ printf("class Number: %d...",whichClass);fflush(stdout);
     while(!feof(class[whichClass].file)){
       docID=hash(documentId);	     
	 strcpy(documentIdOld,documentId);
/*TEST printf("documentID: %s\n",documentId); fflush(stdout);*/
	 docSize=1;class[whichClass].Norma[docID]=0;
	 while(!feof(class[whichClass].file)&&strcmp(documentId,documentIdOld)==0){    
	      fscanf(class[whichClass].file,"%s",term);
	      fscanf(class[whichClass].file,"%d",&freq);
/*TEST   getchar();    printf("docID %d\tterm: %s\t freq: %d\n",docID,term,freq);*/
	          
	      tfi=ft(freq);termPos=0; 
	      
	      termPos=Search(globalCe,term,0,differentTermNumber-1);
/*TEST printf("\ntermine trovato alla posizione %d\n",termPos);*/
	      if(termPos<0){
	      /* printf("\tWarning:The term '%s' is not contained in global centroid\n",term);
	       printf("docID %d\tterm: %s\t freq: %d\n",docID,term,freq);*/
	      }
	      else{
		 IDF = log(((float) numOfDoc)/(float)globalCe[termPos].Offset);
		 
		 /*TEST printf("doc:%d\tterm:%s\t,pos %d freq %f DF %d \t IDF %f IDF*freq:%f\n",docID,term,termPos,tfi,
				 globalCe[termPos].Offset,IDF,tfi*IDF);*/
		 class[whichClass].Norma[docID]+=(tfi*IDF*tfi*IDF);
		 docSize++;
	      }	 
		 fscanf(class[whichClass].file,"%s",documentId);
         }
	 class[whichClass].Norma[docID]=sqrt(class[whichClass].Norma[docID]);
	 /*TEST getchar();printf("document Norma:%f, DocSize:%d
			 docNumber:%s\n",class[whichClass].Norma[docID],docSize,documentIdOld);
	 */	 
     }
   printf("done.\n");  
  }
}  	  
  

task6(struct dict_env my_env, char *extension)
{  
 

 int isUpdated=1, 	/* is 1 if at least a term was written in Global Centroiod*/
     classNumber,
     totalDocumentNumber, //number of document with repetion (in any classes)
     i,j,n,
     totalCorpusDoc_no_repetition, // greater document ID (should be equal to the total number of docs with no repetition
     pointer=0,
     differentWordNumber=0; /* when a term of type o is encountered the number of document which appears in is
     store here an is used for weighting the term of type t*/
    
 float	documentTermWeight,
	centroidMaxWeight=0,
	negativSumOfOther,
        realNumberOfTrainingDocs;
  
 char	term[TERM_LENGHT],
	dictAbsName[PATH_LENGHT],
	weightDictAbsName[PATH_LENGHT],
 	infoDictionariesAbsName[PATH_LENGHT],
	globalCentroidAbsName[PATH_LENGHT],
        orderedCentroidFileName[PATH_LENGHT];
  
 char   sortcommand[200],
	realNumberOfTrainingDocsString[PATH_LENGTH];
 
 struct classFiles class[MAX_CLASS_NUMBER];
 
 struct dictionaryOffset *globalDF;
 	
 FILE 
	*dictWeightFile,
	*dictFile,
	*infoDictionariesFile,
	*globalCentroidFile;
		 
   
   sprintf(infoDictionariesAbsName,"%s/%s",my_env.dict_path,INFO_DICTIONARY);
   if((infoDictionariesFile = fopen(infoDictionariesAbsName,"r"))==NULL){
       printf("file %s not found\n",infoDictionariesAbsName);
       exit(-1);
     } 
    fscanf(infoDictionariesFile,"%s",realNumberOfTrainingDocsString); /*read the number of trainining documents*/
    realNumberOfTrainingDocs=atoi(realNumberOfTrainingDocsString);
    fscanf(infoDictionariesFile,"%s",realNumberOfTrainingDocsString); /*read the number of trainining documents*/
    totalCorpusDoc_no_repetition=atoi(realNumberOfTrainingDocsString);
    fclose(infoDictionariesFile);
         
   sprintf(infoDictionariesAbsName,"%s/%s.%s",my_env.dict_path,INFO_DICTIONARY,extension);
   if((infoDictionariesFile = fopen(infoDictionariesAbsName,"w"))==NULL){
      printf("ERROR: file %s write permission denied\n",infoDictionariesAbsName);
      exit(-1);
    }  
 
   sprintf(globalCentroidAbsName,"%s/%s.%s",my_env.global_centroid_path,GLOBAL_CENTROID,extension);
   globalCentroidFile=fopen(globalCentroidAbsName,"r");
   
   if(globalCentroidFile==NULL){
       printf("file %s does not found\n",globalCentroidAbsName);
       exit(-1);
     }
    /* this is the number of unique document */
   computeDifferentWordNumber(globalCentroidFile,my_env.verbose_switch,&differentWordNumber);
   /* this include the number of document repetition (e.g. a doc belong more then one cats*/
   totalDocumentNumber=computeTotalDocumentNumber(my_env,extension,class, totalCorpusDoc_no_repetition); /* comprends document repetitions */
   printf ("\n\nTotal Number of Categories = %d\n\n",my_env.class_number);
   fprintf(infoDictionariesFile,"Total_Number_of_training_docs= %d\nDifferent_Term_Number= %d\n",
   (int)(realNumberOfTrainingDocs+0.5),differentWordNumber);
      
   
   if (my_env.verbose_switch==ON) 
   	printf("\n\nBuild Dictionaries relative to %s infromation from centroids: \n\n",extension); 

   classNumber=openAllClasses(my_env.splitted_class_path,my_env.class_names,my_env.class_number,
		   my_env.verbose_switch,class,extension,infoDictionariesFile);
   
   if (my_env.verbose_switch==ON)     
      printf("file %s written\n",infoDictionariesAbsName);
   
   sprintf(dictAbsName,"%s/%s.%s",my_env.dict_path,OFFSET_DICTIONARY,extension);
   dictFile = fopen(dictAbsName,"w");   
   if(dictFile==NULL){
      printf("file %s write permission denied\n",dictAbsName);
      exit(-1);
    }
   
   sprintf(weightDictAbsName,"%s/%s.%s",my_env.dict_path,WEIGHT_DICTIONARY,extension);
   dictWeightFile = fopen(weightDictAbsName,"w");  
   if(dictWeightFile==NULL)
    {
      printf("file %s write permission denied\n",dictWeightFile);
      exit(-1);
    }
    
   fseek(globalCentroidFile, 0L, SEEK_SET);
   if (my_env.verbose_switch==ON)printf("\n\n\nLoading Dictionaries\n");
   loadDictionaryOffset(globalCentroidFile, &differentWordNumber, &globalDF);
   if (my_env.verbose_switch==ON)printf("Document Norma Computation\n");
   documentNormaComputation(class,classNumber,globalDF,(int)(realNumberOfTrainingDocs+0.5),differentWordNumber);
   printf("\n\n");
  /* if (my_env.verbose_switch==ON)printf("Classes' Status initialisation\n");*/
   initStatusOfClasses(class,classNumber);
   if (my_env.verbose_switch==ON)printf("Building Dictionary Weights\n");
   isUpdated=1;
   while(isUpdated){
      isUpdated=0;
     /* TEST printf("1\n");*/
      takeNextTermFromClasses(class,classNumber,(int)(realNumberOfTrainingDocs+0.5),globalDF,differentWordNumber);
     /* TEST printf("2\n"); */
      findMinTermOfClasses(class,classNumber);    
     /* TEST printf("3\n"); */
      isUpdated=writeCouplesOnDictionaryWeight
(dictWeightFile,dictFile,class,classNumber,(int)(realNumberOfTrainingDocs+0.5),&pointer,&negativSumOfOther,term,my_env);
     /* printf("4\n");*/
     }
     
   fclose(dictFile);
   fclose(dictWeightFile);
   
   if (my_env.verbose_switch==ON) 
   {
    printf("\n%s written\n",dictAbsName);
    printf("\n%s written\n",weightDictAbsName);
   }
   fprintf(infoDictionariesFile,"Max_Weight= %f\n",centroidMaxWeight);   
   closeAllClassFiles(class,classNumber,infoDictionariesFile);
   
   fclose(infoDictionariesFile);   
   shutdownDictionary(globalDF,differentWordNumber);
   thresholdComputation(my_env, extension);
}  
        


void DictionariesBuilding(struct dict_env my_env) 
{
   if (my_env.verbose_switch==ON) {
   int i;
   
   /* show the environment */
   printf("global_centroid_path = %s\n\n",my_env.global_centroid_path);
   printf("           dict_path = %s\n\n",my_env.dict_path);
   printf("            tmp_path = %s\n\n",my_env.tmp_path);
   
   printf("      verbose_switch = %s\n\n",(my_env.verbose_switch==ON?"ON":"OFF"));
   
   printf("           le_switch = %s\n",(my_env.le_switch==ON?"ON":"OFF"));
   printf("           ne_switch = %s\n",(my_env.ne_switch==ON?"ON":"OFF"));
   printf("           ev_switch = %s\n\n",(my_env.ev_switch==ON?"ON":"OFF"));
   
   printf("     number of centroids = %d\n\n",my_env.centroid_number);
   if(strcmp(my_env.gamma,"-")!=0)
   	printf("	gamma = %s\n\n",my_env.gamma);
   else
   	printf("	gamma file Vector loaded: a gamma for each class adopted\n\n");
   
   for (i=0; i<my_env.centroid_number ; i++)
     printf("     centroid_names[%d] = %s\n",i,my_env.centroid_names[i]);
   }
   if (my_env.le_switch==ON)
      task6(my_env,"le");
   if (my_env.ne_switch==ON)
      task6(my_env,"ne");
   if (my_env.ev_switch==ON)
      task6(my_env,"ev");
}  
    
            
