/*=========================================================================*/
/*---																	---*/
/*---							base_lib.c								---*/
/*---																	---*/
/*---						( Libreria di Base )						---*/
/*---																	---*/
/*=========================================================================*/
/*---																	---*/
/*---	Sono presenti le funzioni di gestione della memoria con i		---*/
/*---	controlli necessari ad assicurarne l'effettivo funzionamento	---*/
/*---																	---*/
/*-------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int ContaAlloc;


char *MYmalloc(len)
unsigned len;
{
  char *ptr;

  /*
  printf("MYmalloc In\n");
  fflush(stdout);
  */

  ptr=malloc(len);

  ContaAlloc++;

  if (ptr==NULL) {
    printf("malloc : ERROR : ptr==NULL\n");
    exit(-1);
  }

  /*
  printf("MYmalloc Out\n");
  fflush(stdout);
  */

  
  return(ptr);
}

char *MYcalloc(len,num)
unsigned len;
unsigned num;
{
  char *ptr;
  int i;

  /*
  printf("MYcalloc In\n");
  fflush(stdout);
  */

  ptr=calloc(len,num);

  for (i=0;i<num; i++)
     ContaAlloc++;

  if (ptr==NULL) {
    printf("calloc : ERROR : ptr==NULL\n");
    exit(-1);
  }

  /*
  printf("MYcalloc Out\n");
  fflush(stdout);
  */

  
  return(ptr);
}

char *MYrealloc(ptrold,len)
char *ptrold;
unsigned len;
{
  char *ptr;
  int i,j;

  /*
  printf("MYrealloc In\n");
  fflush(stdout);
  */

  if (ptrold==(char *)NULL)
  {
     printf("ERROR: realloc called with ptrold==NULL pointer.\n");
     exit(-1);
  }

  ptr=realloc(ptrold,len);

  if (ptr==(char *)NULL) {
    printf("ERROR : realloc returned ptr==NULL.\n");
    exit(-1);
  }

  /*
  printf("MYrealloc Out\n");
  fflush(stdout);
  */

  return(ptr);
}

char *MYstrdup(strold)
char *strold;
{
  char *str;

  /*
  printf("MYstrdup In\n");
  fflush(stdout);
  printf("~%s~\n",strold);
  fflush(stdout);
  */
  str=strdup(strold);

  ContaAlloc++;

  if (str==NULL) {
    printf("strdup : ERROR : str==NULL\n");
    exit(-1);
  }

  /*
  printf("MYstrdup Out %X\n");
  fflush(stdout);
  */

  return(str);
}

void MYfree(ptr)
char *ptr;
{
  /*
  printf("MYfree In\n");
  fflush(stdout);
  */

  if (ptr==NULL) {
    printf("free : ERROR : ptr==NULL\n");
    exit(-1);
  }
  
  /* 
  if (free(ptr) == 0)
      printf("free : ERROR : free failure\n"); 
    scritto cosi` mi dava sempre errore DNMax perche' ho una 'void free()' 
  */

  free(ptr);
  ContaAlloc--;

  /*
  printf("MYfree Out\n");
  fflush(stdout);
  */

}


void MYmemory(Commento)
char *Commento;
{
  printf("MYmemory : %s %d\n",Commento,ContaAlloc);
}

void MYreset(Commento)
char *Commento;
{
  ContaAlloc = 0;
  printf("MYreset : %s\n",Commento);
}
