/***********************************************************************/
/*   Text Categorization Framework                                     */
/*                                                                     */
/*                                                                     */
/*   Author: Alessandro Moschitti                                      */
/*   moschitti@info.uniroma2.it                                        */
/*   Date: 30.11.03                                                    */
/*                                                                     */
/*   Copyright (c) 2003  Alessandro Moschitti - All rights reserved    */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/




#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>
#include "classifier.h"


 

/* Compute  a frequency term slight modifed */
 
float ftTerm(int freq, char *term, int n){
	
	if(freq==0)return 0;
	else return ((float)log((float)freq*terminologicalWeigth(term))+1);
}



float ft(int freq){
	
	if(freq==0)return 0;
	else return ((float)log((float)freq)+1);
}

/*
float ft(int freq){
	
	 return ((float)freq);
}*/

int hash (char *documentId)
{
  int	chunkId,
	docId; /* inside the class */
  
  chunkId=atoi(documentId)/HASH_COSTANT;
  docId=atoi(documentId)-chunkId*HASH_COSTANT;
  return MAX_NUMBER_OF_DOC_PER_CLASS*chunkId + docId; /*create another index to save memory*/
}  



int buildExtractedDocumentCentroid(FILE *classFile,struct docVect *docCentroid,long *pos, 
				   char *documentIdOld, struct CKB_env clKB)
  {
   char	  
	documentId[TERM_LENGHT],
        *term,*punt,
	line[FREAD_BUFFER_SIZE];
     
   struct couples setOfCouples;
   int numberOfCouple;
   
   int 	freq,
	centroidSize=0;
   
   float IDF;
       
     fseek(classFile,*pos,SEEK_SET);
     fscanf(classFile,"%s",documentId); // take the document id
     strcpy(documentIdOld,documentId);
      
     while(!feof(classFile)&&strcmp(documentId,documentIdOld)==0){


       fgets(line,FREAD_BUFFER_SIZE,classFile);
       term=line+1; // set the pointer at the beginning of the term
       
//printf("<%s>---><%s>\n",documentId,term);	
       if(strncmp(term,"SPT#",4) == 0) {
	     punt=term+strlen(term); 
	     while(*punt!=')' && punt>term )punt--; //remove freq and "\n"
	     *(punt+1)=0;

	     docCentroid[centroidSize].term = (char *)MYstrdup(term+4); 
	     docCentroid[centroidSize].weight=-1;
	     docCentroid[centroidSize].offset=-1; // no feature => no off-set
//printf("documentId %s term %s\n",documentId,docCentroid[centroidSize].term);

	     centroidSize++;

       	    }
	else{

	    if(strstr(term,"\t")==NULL) term=strtok(term," "); // the delimeter is maybe space
	    else if(strstr(term," ")==NULL) term=strtok(term,"\t"); // delimeter is maybe tab
		  else if(strstr(term,"\t")>strstr(term," ")) term=strtok(term," "); // the delimeter is the nerarest
			else term=strtok(term,"\t"); 

   	    docCentroid[centroidSize].term = (char *)MYstrdup(term);

//printf("term <%s>\n",term);

	    if(strstr(term+strlen(term),"\t")==NULL)  term=strtok(NULL,"\t"); // the delimeter is maybe space
	    else if(strstr(term+strlen(term)+1," ")==NULL)term=strtok(NULL,"\t"); // delimeter is maybe tab
		  else if(strstr(term+strlen(term)+1,"\t")>strstr(term+strlen(term)+1," ")) term=strtok(NULL," "); // the delimeter is the nerarest
			else  term=strtok(NULL,"\t"); 

//printf("term <%s>\n",term);

	    freq=0;
	    if(term!=NULL)freq=atoi(term); // take the frequency

            if(freq==0){
		printf("ERROR: freq=0 problem in the learning file\n\n");
		exit(-1);
	    }


           //printf("documentId %s term %s freq %d \n",documentId,docCentroid[centroidSize].term,freq);

fflush(stdout);
	    if(couplesRelativeToTerm(clKB.weightDictFile,docCentroid[centroidSize].term,
               &setOfCouples,clKB.offsetDictArray,clKB.differentWordNumber,&docCentroid[centroidSize].offset)
			    !=-1){
	    IDF = log(((float)clKB.totalDocumentNumber)/(float)setOfCouples.numOfDocWithCurrentTerm);
	    docCentroid[centroidSize].weight=ft(freq)*IDF;


	    /*TEST 
	    printf("documentId %s term %s freq %d weight %f\n",
		    documentId,docCentroid[centroidSize].term,freq,
			    docCentroid[centroidSize].weight);
	    */
	    centroidSize++;
	    }
       }
	
       *pos=ftell(classFile);
       fscanf(classFile,"%s",documentId);     
     }

  return centroidSize;
	 
  }  
  

  int buildCleanedDocumentCentroid(FILE *classFile,struct dictionary *docCentroid,long *pos, 
		  char *documentNumber,char **stopWord,int numberOfSW)
  {
   char	  
	documentId[TERM_LENGHT],
	documentIdOld[TERM_LENGHT],
      	term[TERM_LENGHT],
	termExp[TERM_LENGHT],
	*singleTerm,
        syntClass[TERM_LENGHT],
        singleTermWithPos[TERM_LENGHT];   
   
   int 	i,
	freq,
        mult,
	centroidSize=0,
	numOfWord=0;
       
     fseek(classFile,*pos,SEEK_SET);
     fscanf(classFile,"%s",documentId);
     strcpy(documentIdOld,documentId);
     while(!feof(classFile)&&strcmp(documentId,documentIdOld)==0){    
       fscanf(classFile,"%s",term);
       fscanf(classFile,"%s",syntClass);
       fscanf(classFile,"%d",&freq);
       fscanf(classFile,"%d\n",&mult); /*read multeplicity but don't use it*/
             
      /*TEST printf("%s\n",documentId);
       printf("%s\n",term);
       printf("%d\n\n",freq);*/
       if(strlen(term)>1){
		       
#ifndef YELLOW_PAGES
	  	          
	   /* Trasform word in lower case type 
	       
	       for(i=0;i<strlen(term);i++)     
	     term[i]=tolower(term[i]); */   
	       
	  /*Add all the words compounded the terminological expression above */
	  
	  strcpy(termExp,term);
	  
	  if(termExp[strlen(termExp)-1]=='\'')termExp[strlen(termExp)-1]='\0';
	  
	  singleTerm=strtok(termExp,"_");
	  
	  if(strlen(singleTerm)>strlen(term)-2)numOfWord=1;
	  else numOfWord=2;
	  
	  /*TEST printf("singleterm <%s> term <%s> numofword %d\n",singleTerm,term,numOfWord);*/
	  
	  if(termExp[0]=='\'')singleTerm++;
	  	  

	  while (singleTerm!=NULL){
	      
              if(SearchInStopList(stopWord,singleTerm,0,numberOfSW-1)==-1 && strcmp(singleTerm,"")!=0){
		#ifdef SYNTACTIC_INFO
		 strcpy(singleTermWithPos,singleTerm);     
		 strcat(singleTermWithPos,"-");  /*WITH SYNTACTIC INFORMATION (POS INF)*/    
		 if(numOfWord>1 || strcmp(syntClass,"P")==0)strcat(singleTermWithPos,"N");
		 else strcat(singleTermWithPos,syntClass);
        	 centroidSize=unifieLemma(singleTermWithPos,freq,docCentroid,centroidSize);
		#endif
		#ifndef SYNTACTIC_INFO
		 centroidSize=unifieLemma(singleTerm,freq,docCentroid,centroidSize);
		#endif 
		 
              }
	       singleTerm=strtok(NULL,"_");
    	   }
	  
	/*TEST  printf("numero di parole %d\n",numOfWord);*/
	   /* Add terminological expression */ 
	if((SearchInStopList(stopWord,term,0,numberOfSW-1)==-1) && numOfWord>1){
	  /* erase '' */
	    singleTerm=term;	  
	    if(term[0]=='\'')singleTerm++;
            if(term[strlen(term)-1]=='\'')term[strlen(term)-1]='\0';
	/*TEST    printf("aggiungo la feature %s\n",termExp);*/
	    #ifdef SYNTACTIC_INFO
		 strcat(singleTerm,"-");strcat(singleTerm,"N");  /*WITH SYNTACTIC INFORMATION (POS INF)*/    
            #endif
	    centroidSize=unifieLemma(singleTerm,freq,docCentroid,centroidSize);
    	  }
#endif         	       	   
#ifdef  YELLOW_PAGES        
	 if(SearchInStopList(stopWord,term,0,numberOfSW-1)==-1){
	 #ifdef  REMOVE_APEXES		 
	 if(termExp[strlen(termExp)-1]=='\'')termExp[strlen(termExp)-1]='\0';
	 if(termExp[0]=='\'')singleTerm++;
	 #endif  /* REMOVE_APEXES */
	    #ifdef SYNTACTIC_INFO
		 strcat(term,"-");strcat(term,syntClass);  /*WITH SYNTACTIC INFORMATION (POS INF)*/  
	    #endif
		 	   	  
             centroidSize=unifieLemma(term,freq,docCentroid,centroidSize);
     	 }
#endif
     } 	 	    
       *pos=ftell(classFile);
       fscanf(classFile,"%s",documentId);     
  }
     strcpy(documentNumber,documentIdOld);
     return centroidSize;  
        
}  


/* Open all Centroids */

int openAllCentroids(char *centroid_path, char **centroid_names,int  centroid_number,short verb,
                    struct centroid *centroids, char *extension, FILE *dictionaryInfo)
  {
   int j,
       whichClass;
      
   char className[PATH_LENGHT],
	centroidAbsFileName[PATH_LENGHT];
   
   
   j=0;
   for(whichClass=0;whichClass<centroid_number;whichClass++) 
     {
    	  
      sprintf(centroidAbsFileName,"%s/%s.%s.oce",centroid_path,centroid_names[whichClass],extension);
      centroids[j].file=fopen(centroidAbsFileName,"r");

      if(centroids[j].file==NULL) {
           if (verb==ON)
	          printf("Warning : file %s does not found\n",centroidAbsFileName);
      } else {
	   if (verb==ON)
	   printf("\t\t%s\n",centroidAbsFileName);
	   j++;
	   if(dictionaryInfo!=NULL) {
	       fprintf(dictionaryInfo,"%s\n",centroid_names[whichClass]);
	       /*TESTprintf("centroid_names[%d]=%s\n",whichClass,centroid_names[whichClass]);*/
	   }

      }
	 
     }	
    return j;
  } 

/* Open all Centroids */

int openAllClasses(char *class_path, char **class_names,int  class_number,short verb,
                    struct classFiles class[], char *extension, FILE *dictionaryInfo)
  {
   int j,
       whichClass;
      
   char className[PATH_LENGHT],
	orderedClassName[PATH_LENGHT],
	sortcommand[PATH_LENGHT];
   
   
   j=0;
   for(whichClass=0;whichClass<class_number;whichClass++) 
     {
    	  
	 sprintf(className,"%s/%s.%s",class_path,class_names[whichClass],extension);
	 sprintf(orderedClassName,"%s.o",className);
	 if (verb==ON)printf("\topening class file: %s\n",className);
	 class[j].file=fopen(className,"r");
	 if((class[j].ordFile=fopen(orderedClassName,"r"))==NULL){

	     /* sort class on file */
	     if (verb==ON)printf("Sorting of classes by term\n");
	     sprintf(sortcommand,"sort -k 2,3 -o %s %s",orderedClassName,className);

	     if(system(sortcommand)!=0) {
		 printf("\nERROR : Class %s was not ordered\n",className);
  		 exit(-1);
	     }
	     class[j].ordFile=fopen(orderedClassName,"r");
	  }
	  else if (verb==ON)printf("Classes sorted yet\n");


	 if(class[j].file==NULL) {
              if (verb==ON)
	             printf("Warning : file %s does not found\n",className);
	 } else {
	      if (verb==ON)
	      printf("\tclass %s ordered in %s\n\n",className,orderedClassName);
	      j++;
	      if(dictionaryInfo!=NULL) {
		  fprintf(dictionaryInfo,"%s\n",class_names[whichClass]);
		  /*TESTprintf("centroid_names[%d]=%s\n",whichClass,centroid_names[whichClass]);*/
	      }
           }

     }	
    return j;
  } 

    
/* close all files for task6*/

void closeAllClassFiles(struct classFiles class[], int n, FILE *dictionaryInfo)
{
  int i;
  if(dictionaryInfo!=NULL)
    fprintf(dictionaryInfo,"centroidTotalFreqs\n");
  for(i=0;i<n;i++){
     fclose(class[i].file);
     fclose(class[i].ordFile);
     MYfree(class[i].Norma);
     if(dictionaryInfo!=NULL)
       fprintf(dictionaryInfo,"%f\n",class[i].numOfDocuments);
  }
}

/* close all files for task2e3 */

void closeAllCentroidFiles(struct centroid *centroids,int n)
{
  int i;
  for(i=0;i<n;i++){
     fclose(centroids[i].file);
  }
}
    
 
/*finds min among currentTerm*/


void findMinElementOfCentroids(struct centroid *centroids, int classNumber)
{
 int i,j;
  char min[FREAD_BUFFER_SIZE];
  strcpy(min,"~~~");for(j=0;j<classNumber;j++)centroids[j].status=0;
  
  for(i=0;i<classNumber;i++)
     if(strcmp(min,centroids[i].currentTerm)==0)centroids[i].status=1;
      else 
        if(strcmp(min,centroids[i].currentTerm)>0)
         {
       	  for(j=0;j<classNumber;j++)centroids[j].status=0;
       	  strcpy(min,centroids[i].currentTerm);centroids[i].status=1;
         }
 }
 
 
void updateCurrentElementOfCentroids(struct centroid *centroids, int classNumber)
{
 int i;
 
 for(i=0;i<classNumber;i++)   
     if(centroids[i].status &&!feof(centroids[i].file))
 	{ 
	 fscanf(centroids[i].file,"%s",centroids[i].currentTerm);
         if(!feof(centroids[i].file)){
	   fscanf(centroids[i].file,"%d",&centroids[i].currentFreq);
	   fscanf(centroids[i].file,"%d",&centroids[i].currentNumberOfDoc);
	   /*TEST printf("term:%s\tDF%d\n",centroids[i].currentTerm,centroids[i].currentNumberOfDoc);*/
   	 }
	 else 
	    {
	     strcpy(centroids[i].currentTerm,"~~~");
	     centroids[i].currentFreq=0;
	     centroids[i].currentNumberOfDoc=0;
     	    }
   	}
}    
    


int mergeInGlobalCentroid(FILE *fileGlobalCen,FILE *fileDict,struct centroid *centroids, int classNumber,
		          int *totalDocNumber)
{ 		
  int sum=0,sum2=0;
  int i;
  char min[FREAD_BUFFER_SIZE];
  
      for(i=0;i<classNumber;i++)   
         if(centroids[i].status==1)
           {
            sum+=centroids[i].currentFreq;
	    sum2+=centroids[i].currentNumberOfDoc;
            strcpy(min,centroids[i].currentTerm);
           }

      if(strcmp(min,"~~~")!=0)
        {
         fprintf(fileGlobalCen,"%s\t%d\n",min,sum2);
         fprintf(fileDict,"%s\n",min);
         *totalDocNumber += sum2;
	 return 1;
        } 
      else return 0;
}


int writeCouplesOnDictionaryWeight(FILE *fileDictionaryWeight, FILE *fileDICT, 
		struct classFiles *class,int classNumber, int totalDocumentNumber,int *pointer,
		float *negativSumOfOther, char *term, float gamma)
{ 		
  char min[FREAD_BUFFER_SIZE],
       dati[FWRITE_BUFFER_SIZE];
  
  int	coupleNumber=0,
	i,
	totalNumOfDocWithCurrentTerm=0,		  
	whichClass,
	numOfDocWithCurrentTermNotInClass;
       
  float IDF,
	weight,
	negativSum,
	terminologyFactor;


		  /*Classi usate per RIAO
		  
		  gam[]={4,9,8/*-1,16,0.0,0.0,16,10.0,0.0,0.0,0.0,0.30,10.0,0.0,14,11,/*-18,9,0.0,0.0,0.060,2,0.0,0.90,11,2,10.0,7.2,4,13,0.0,0.50,0.40,10.0,7.2,10.0,11,2,-1,13,/*-18,14,10.0,0.0,4,0.50,7.3,2,5,0.0,13,0.0,0.0,0.0,9,0.0,0.0,10.0,0.0,0.920,10.0,0.0,0.0,0.0,0.0,0.0,0.10,0.0,0.0,2,10.0,11,16,14,3,7,0.30,14,0.70,0.60,6,3,0.0,0.0,10.0,14,8,10.0,13,0.0,3,0.20,0.0}
		  
  
  /*caso base*/
  
  
float 
gam[]={0.940,10.0,/*-1*/8,10.0,0.30,0.0,5,8,0.0,0.0,16,14,8,0.0,16,13,/*-1*/8,10.0,0.0,0.0,0.0,0.80,0.0,0.90,6,6,5,8,0.0,16,10.0,5,11,10.0,9,/*-1*/8,14,0.20,/*-1*/8,12,/*-1*/8,10.0,0.50,0.0,10.0,0.0,6,2,5,0.0,15,0.0,0.0,0.50,10.0,/*-1*/8,0.0,10.0,0.0,0.0,10.0,0.0,0.0,0.0,0.0,0.0,0.0,8,0.0,10.0,10.0,12,14,13,16,10.0,5,12,10.0,10.0,11,0.0,0.0,0.0,10.0,3,9,15,16,0.0,12,2,2};
  
  
  
  struct couple datoCentroid;
      
      for(i=0;i<classNumber;i++)   
         if(class[i].status==1){
	      coupleNumber++;           
	      strcpy(min,class[i].currentTerm);
	      totalNumOfDocWithCurrentTerm+=class[i].numOfDocWithCurrentTermInClass;
          }   
	    
      if(strcmp(min,"~~~")!=0) 
	{ 
         putw(coupleNumber,fileDictionaryWeight);    /* couples number*/
	 putw((long)totalNumOfDocWithCurrentTerm,fileDictionaryWeight);
	 /* TEST printf("freq globale del term %s:%d\n	",min,globalCentroidFreq);*/
	 
	 if((min[strlen(min)-4]=='-')&&(min[strlen(min)-3]=='o')){
		  strcpy(term,min);
 
		  /*TEST
		  printf("\n-----------------------------------------------------------------------------\n");  
		printf("\n termine:%s doc in cui e' presente 'o':%d\n",
		min,*numOfDocForOtherTerm);*/
	}
		
         for(i=0;i<classNumber;i++)   /* couples centroid weight */
           if(class[i].status)
            {
	     /* Rocchio's weight formula computation */
	     /*TEST printf("weight of term %s:%f\n",min,class[i].currentWeight);*/
		    
	     /* SU fotocopie di michele c'e' questa:
	       datoCentroid.weight= class[i].currentWeight/(class[i].numOfDocWithCurrentTermInClass);
	       
	       ed ho sperim. che fa schifo*/
	      
			      
	    /*ITTNER ORIGINAL*/ datoCentroid.weight=  class[i].currentWeight/class[i].numOfDocuments;	      
	     
	     /* Sempre Fotocopie di Michele */
	     
	    
	     numOfDocWithCurrentTermNotInClass=
	     			totalNumOfDocWithCurrentTerm-class[i].numOfDocWithCurrentTermInClass;
	     				   
	     /*TEST printf("Data of term %s of class :%d\n",min,i+1);*/
	     
	     negativSum=0;
	     if(numOfDocWithCurrentTermNotInClass>0)
	     for(whichClass=0;whichClass<classNumber;whichClass++)
		 if(class[whichClass].status==1 && i != whichClass)
		 /* forocopir di Michele: 
		  	negativSum+=(class[whichClass].currentWeight/numOfDocWithCurrentTermNotInClass)); */ 
				     
	        /*TEST  printf("term: %s num pos doc %d num neg doc %d\n",min,
			class[i].numOfDocWithCurrentTermInClass,numOfDocWithCurrentTermNotInClass);*/
	       
	     /*ITTNER ORIGINAL */
			     
	     negativSum+=(class[whichClass].currentWeight
				/(totalDocumentNumber-class[i].numOfDocuments));
	        
	     /*TEST printf("positiv %f - Negativ %f\n",datoCentroid.weight,negativSum);*/
	        
#ifdef GAMMA_PER_CLASS
	     datoCentroid.weight= (BETA * datoCentroid.weight  - gam[i] * negativSum);
#endif
#ifndef GAMMA_PER_CLASS 
	     datoCentroid.weight= (BETA * datoCentroid.weight  - gamma * negativSum);
#endif	        
	     
	     	     
					     
	     if(datoCentroid.weight<0)datoCentroid.weight=0;

	     
	     /*TEST printf("profile weight: %f num of pos,neg %d,%d\n",datoCentroid.weight,class[i].numOfDocWithCurrentTermInClass,numOfDocWithCurrentTermNotInClass);
	     	     getchar();*/
	     
	    /* IDF =log(((float)totalTermNumber)/(float)globalCentroidFreq);
             weight = IDF * centroids[i].currentFreq;
	     if(*weightMax<weight)*weightMax=weight;*/
			     
             /*TEST printf("termine=%s peso: %f\n",min,datoCentroid.weight);*/

	     datoCentroid.centroidNumber=i;
             writeCouples((char *)&datoCentroid,dati,sizeof(struct couple));
             fwrite(dati,sizeof(struct couple),1,fileDictionaryWeight);
            }
         fprintf(fileDICT,"%s\t%d\n",min,*pointer);
         *pointer+=(coupleNumber*sizeof(struct couple)+2*sizeof(int));
	 
	 return 1;
        } 
        else return 0;
}

int computeDifferentWordNumber(FILE *fileGlobalCen, short verbose, int *differentWordNumber)
{  
  int sum=0,
      freq,
      documentNumber;
  
  char term[FREAD_BUFFER_SIZE],
       globalCentroidAbsName[PATH_LENGHT];
  
   (*differentWordNumber)=0;

   fscanf(fileGlobalCen,"%s",term);
     while(!feof(fileGlobalCen))
      {    
       fscanf(fileGlobalCen,"%d",&documentNumber);
       sum+=documentNumber;
       (*differentWordNumber)++;
       fscanf(fileGlobalCen,"%s",term);
      }
   return sum;       
} 

int computeTotalDocumentNumber(struct dict_env my_env, char *extension,struct classFiles class[])
{
  FILE *classFile;
  
  int sum=0,
      whichClass;
    
  char classAbsFileName[PATH_LENGHT];
   printf("\n\tCLASS\tnum of doc inside class\tcomulative sum");
  for(whichClass=0;whichClass< my_env.class_number;whichClass++){
      sprintf(classAbsFileName,"%s/%s.%s",my_env.splitted_class_path,my_env.class_names[whichClass],extension);

      if((classFile=fopen(classAbsFileName,"r"))==NULL) {
           if (my_env.verbose_switch==ON)
	          printf("Warning : file %s does not found\n",classAbsFileName);
      } else {
	  class[whichClass].numOfDocuments=countDocument(classFile);
	  sum=sum+class[whichClass].numOfDocuments;
	  printf("\n\t%s\t\t\t%d\t\t\t%d",my_env.class_names[whichClass],class[whichClass].numOfDocuments,sum);
	  /*viene lasciato lo spazio per tutti i doc del corpus*/
	  class[whichClass].Norma=
	  (float*)MYmalloc((int)(MAX_CHUNK_NUMBER*MAX_NUMBER_OF_DOC_PER_CLASS*sizeof(float)));
        }
      fclose(classFile);
  }   
   return sum;   
	     
} 


void initStatusOfCentroids(struct centroid *centroids,int classNumber)
{
 int i;
 for(i=0;i<classNumber;i++){
     centroids[i].status=1;
     centroids[i].currentNumberOfDoc=0;
     }	 
}

void initStatusOfClasses(struct classFiles *class,int classNumber){
 int i;
 for(i=0;i<classNumber;i++){
     class[i].status=1;
     class[i].currentWeight=0;
     }	 
}

void takeNextTermFromClasses(struct classFiles class[], int classNumber,int numOfDoc, 
			struct dictionaryOffset *globalCe, int differentTermNumber){
 int  whichClass,
      freq,
      docID,
      termPos,
      filePos,
      totalNumOfDocWithCurrentTerm;
 
  char	
	documentId[TERM_LENGHT],
	termNew[TERM_LENGHT];
  
  float tfi;
  
  
  for(whichClass=0;whichClass<classNumber;whichClass++)
	     
    if(class[whichClass].status &&!feof(class[whichClass].ordFile)){ 

	fscanf(class[whichClass].ordFile,"%s",documentId);
	      /*TEST	printf("documentId:%s\n",documentId);*/

	fscanf(class[whichClass].ordFile,"%s",class[whichClass].currentTerm);
	     /*TEST printf("termOld:%s\n",class[whichClass].currentTerm);*/
	  
	 /*TEST printf("current term of class
	 %d/%d:\t%s\n\n",whichClass,classNumber,class[whichClass].currentTerm);*/
	/*termPos=0;     
    if(strcmp("'---'-A",class[whichClass].currentTerm)!=0)*/
	   termPos=Search(globalCe,class[whichClass].currentTerm,0,differentTermNumber-1);
	if(termPos<0){
	    printf("\tWarning:The term '%s' is not contained in global centroid\n",
			    class[whichClass].currentTerm);
	    printf("class %d\tterm: %s\n",whichClass,class[whichClass].currentTerm);
        }
	else{	
	     strcpy(termNew,class[whichClass].currentTerm);
	     class[whichClass].numOfDocWithCurrentTermInClass=0;
	     class[whichClass].currentWeight=0;
	     totalNumOfDocWithCurrentTerm=globalCe[termPos].Offset;/* the dictionary was loaded vith globalcentroid
	     argument*/

	     while(!feof(class[whichClass].ordFile)&&
		    strcmp(termNew,class[whichClass].currentTerm)==0){
		     
	       fscanf(class[whichClass].ordFile,"%d",&freq);
	       tfi=ft(freq);
	      
/*Heavier weight to
	
TEMINOLOGY
tfi*=4.3; for all

	       if((termNew[strlen(termNew)-4]=='-')&&(termNew[strlen(termNew)-3]=='t'))
		tfi*=terminologicalWeigth(termNew);*/
			
/*TEST 		printf("freq:%d\n",freq);*/
	       
	       docID=hash(documentId);
	       class[whichClass].currentWeight+=
		    (tfi*
		     log((float)numOfDoc/(float)totalNumOfDocWithCurrentTerm)/
		     class[whichClass].Norma[docID]);
		    /* !!!!! IDF=1
				     tfi/
		     class[whichClass].Norma[docID];*/
				     
			       
			       

	       /*TEST printf("class:%d doc %d term: %s,
			       contributeWeight:%f\n",whichClass,docID,termNew,(ft(freq)*
		     log((float)numOfDoc/(float)totalNumOfDocWithCurrentTerm)/
		     class[whichClass].Norma[docID]));*/

	       filePos=ftell(class[whichClass].ordFile);
	       class[whichClass].numOfDocWithCurrentTermInClass++;

	       fscanf(class[whichClass].ordFile,"%s",documentId);
	       fscanf(class[whichClass].ordFile,"%s",termNew);
	       
	       /*TEST   printf("norma of doc %d:%f term: %s,
			       weight:%f\n",docID,class[whichClass].Norma[docID]
	      ,class[whichClass].currentTerm,class[whichClass].currentWeight);
	       getchar();
              */
	     }
	     
	    if(!feof(class[whichClass].ordFile))
		    fseek(class[whichClass].ordFile,filePos,SEEK_SET);   
       }
  }
  else if(class[whichClass].status)
		  	strcpy(class[whichClass].currentTerm,"~~~"); 
              	  
}
 


/*finds min among currentTerm*/


void findMinTermOfClasses(struct classFiles *class,int classNumber){
 int i,j;
  char min[TERM_LENGHT];
  strcpy(min,"~~~");
  for(j=0;j<classNumber;j++)
  { /*TESTprintf("term of class %d:  %s\n",j,class[j].currentTerm);*/class[j].status=0;}
  
  for(i=0;i<classNumber;i++)
     if(strcmp(min,class[i].currentTerm)==0)class[i].status=1;
      else 
        if(strcmp(min,class[i].currentTerm)>0){
       	  for(j=0;j<classNumber;j++)class[j].status=0;
       	  strcpy(min,class[i].currentTerm);
	  class[i].status=1;
         }
	 
  /*printf("minimum %s\n",min);*/
 }
 	 

