#include "classifier.h"
#include <math.h>
#include <string.h>
#include "lista.c"

#define OUTPUT_STDSCARTI
#define MAX_CICLE_NUMBER 25

#define MAX_DOCS_TEST 10000
#define MAX_DOCS_TRAINING 25000
#define NUM_CAT 100

/*typedef struct elemento_appo
   {
    float prod;
    struct elemento_appo *succ;
   }elemento;
*/

typedef struct elemento_risultato
{
	char *Iddoc;
	char *categoria1;
	char *categoria2;
	
}elemento_ris;

typedef struct rilevanza_appo
{
	char categoria[40];
	float media[13];
	elemento *testa; 
	    		/*ATTENZIONE BISOGNA INIZIALIZZARLO A NULL*/
}rilevanza;

rilevanza rel[NUM_CAT];



/*********************************************************************************************/
/***				Heading of PROCEDURES					   ***/
/*********************************************************************************************/


/*********************************************************************************************/
/***				Load KB info file prendere da dictionary		   ***/
/*********************************************************************************************/


int loadClassificationKB(struct clustering_env my_env, char *extension, struct CKB_env *clKB) {
  char etichetta[TERM_LENGHT];
  char dictAbsName[PATH_LENGHT];
  char weightDictAbsName[PATH_LENGHT];
  char infoDictionariesAbsName[PATH_LENGHT];
  int i=0;

    
  FILE *infoDictionariesFile;
  FILE *offsetDictFile;
  FILE *weightDictFile;
   
  /* -------------------------------- */
  /* Reading Dictionaries information */
  /* -------------------------------- */
  if (my_env.verbose_switch==ON) printf ("Reading Dictionaries information from");

  sprintf(infoDictionariesAbsName,"%s/%s.le",my_env.dict_path,INFO_DICTIONARY);
  printf("%s\n",infoDictionariesAbsName);
  if((infoDictionariesFile = fopen(infoDictionariesAbsName,"r"))==NULL) {
      printf("file %s does not found\n",infoDictionariesAbsName);
      return 0;
  }
    
  fscanf(infoDictionariesFile,"%s\n%d\n%s\n%d\n",
		              etichetta,&(clKB->totalDocumentNumber),
		              etichetta,&(clKB->differentWordNumber));
  clKB->centroidNumber=0;
  
    /* Centroid Names reading 

  fscanf(infoDictionariesFile,"%s\n",clKB->centroidNames[clKB->centroidNumber]);
  while(!feof(infoDictionariesFile)&& strcmp(clKB->centroidNames[clKB->centroidNumber],"Max_Weight=")!=0){
    if (my_env.verbose_switch==ON) 
	   printf("centroidNames[%d]=%s\n",clKB->centroidNumber,clKB->centroidNames[clKB->centroidNumber]);
    clKB->centroidNumber++;
    fscanf(infoDictionariesFile,"%s\n",clKB->centroidNames[clKB->centroidNumber]);
  }
  
  fscanf(infoDictionariesFile,"%f\n%s",&(clKB->maxWeight),etichetta);  /* max weight reading */
    
    /* Centroid total Frequences reading 
  i=0;
  fscanf(infoDictionariesFile,"%f\n",&clKB->centroidTotalFreqs[i]);
  while(!feof(infoDictionariesFile)&&i<clKB->centroidNumber){	  
    if (my_env.verbose_switch==ON) 
	   printf("centroidTotalFreq[%d]=%f\n",i,clKB->centroidTotalFreqs[i]);
    i++;
    fscanf(infoDictionariesFile,"%f\n",&clKB->centroidTotalFreqs[i]);
  }
  
  
    /* Average, STD Deviation reading (of positive) 
  i=0;
  fscanf(infoDictionariesFile,"%s%f\n",etichetta,&clKB->positiv[i].average);
  while(!feof(infoDictionariesFile)&&i<clKB->centroidNumber){
    fscanf(infoDictionariesFile,"%f\n",&clKB->positiv[i].stdDeviation);	  
    if (my_env.verbose_switch==ON){
	   printf("positiv[%d].average=%f\t",i,clKB->positiv[i].average);
	   printf("positiv[%d].stdDeviation=%f\n",i,clKB->positiv[i].stdDeviation);
    }
    fscanf(infoDictionariesFile,"%f\n",&clKB->positiv[++i].average);
  }
  
    /* Average, STD Deviation reading of negative 
  i=0;
  fscanf(infoDictionariesFile,"%s%f\n",etichetta,&clKB->negativ[i].average);
  while(!feof(infoDictionariesFile)&&i<clKB->centroidNumber){
    fscanf(infoDictionariesFile,"%f\n",&clKB->negativ[i].stdDeviation);	  
    if (my_env.verbose_switch==ON){
	   printf("negativ[%d].average=%f\t",i,clKB->negativ[i].average);
	   printf("negativ[%d].stdDeviation=%f\n",i,clKB->negativ[i].stdDeviation);
    }
    fscanf(infoDictionariesFile,"%f\n",&clKB->negativ[++i].average);
  }
  */
  fclose(infoDictionariesFile);
  
  
  /* -------------------------------- */
  /* Reading dictionaryOffset 	      */
  /* -------------------------------- */

  sprintf(dictAbsName,"%s/%s.le",my_env.dict_path,OFFSET_DICTIONARY);
  if((offsetDictFile = fopen(dictAbsName,"r"))==NULL) {
      printf("file %s does not found\n",dictAbsName);
      return 0;
  }
  sprintf(weightDictAbsName,"%s/%s.le",my_env.dict_path,WEIGHT_DICTIONARY);
  if((clKB->weightDictFile = fopen(weightDictAbsName,"r"))==NULL) {
      printf("file %s does not found\n",weightDictAbsName);
      return 0;
  }

  if (my_env.verbose_switch==ON) printf ("loading Offset Dictionary ... "); 
  loadDictionaryOffset(offsetDictFile,&clKB->differentWordNumber,&clKB->offsetDictArray);
//  if (my_env.verbose_switch==ON) printf ("Dictionary Loaded !\n");    

  fclose(offsetDictFile);
  
  }

short sgn(float x){
	if(x>=0) return 1;
	else return -1;
 }
  

/* unifica prendere da centroid.c */ 
 
int unifieLemma(char *term, int freq, struct dictionary *centroid, int centroidSize){
  
  int i;
       for(i=0;i<centroidSize;i++)
	  if (strcmp(term,centroid[i].term)==0) {
              /*TEST printf("key %s already present\n",term);*/
              centroid[i].freq+=freq;
	      i=centroidSize+2;
	  }  
       if(i<centroidSize+2){
               /*TEST printf("key %s added at the end\n",term);*/
	       
	       strcpy(centroid[centroidSize].term,term);     
               centroid[centroidSize].freq=freq;
	       centroidSize++;
       }
   return centroidSize;    
   } 
   
/* prendere sempre da centroid.c */
   
   
int buildDocumentCentroid(FILE *documentFile, 
		struct dictionary *docCentroid){
	  
   char 
	documentId[TERM_LENGHT],
      	term[TERM_LENGHT];   
   
   char  documentAbsName[PATH_LENGHT];
   
   int freq,centroidSize=0;    
     
	     
     fscanf(documentFile,"%s",documentId);
     while(!feof(documentFile)){    
       fscanf(documentFile,"%s",term);
       fscanf(documentFile,"%d",&freq);
       /*TEST printf("%s\n",documentId);
       printf("%s\n",term);
       printf("%d\n\n",freq);*/ 
              		                
       centroidSize=unifieLemma(term,freq,docCentroid,centroidSize);  
       fscanf(documentFile,"%s",documentId);
    }
       
   return centroidSize; 
        
}  
  

void shutdownClassificationKB(struct CKB_env *clKB){
  int i;
  	
  for(i=0;i<clKB->differentWordNumber;i++)
	  MYfree(clKB->offsetDictArray[i].term);
  
  MYfree(clKB->offsetDictArray);
  fclose(clKB->weightDictFile);
  
}

void shutdownOracle(struct oracleCell *oracle, int numOfdoc){
  int cellIndex,
      classIndex;
  	
  for(cellIndex=0;cellIndex<numOfdoc;cellIndex++){
     classIndex=0;
     while(oracle[cellIndex].targetClass[classIndex]!=NULL){
	  MYfree(oracle[cellIndex].targetClass[classIndex]);
	  classIndex++;
     }
  MYfree(oracle[cellIndex].targetClass);
  }
  MYfree(oracle);
}


int computeNumberOfCorpusDoc(FILE *oracleFile)
{
 
 int numOfCorpusDoc=0;
 char class[MAX_CLASS_LENGHT];
 char idDoc[ID_DOC_LENGHT];
 char idDocOld[ID_DOC_LENGHT];
 
 fscanf(oracleFile,"%s",idDoc);
 (*idDocOld)='\0';
 while(!feof(oracleFile)){
      
      fscanf(oracleFile,"%s",class);
      if(strcmp(idDoc,idDocOld)!=0)numOfCorpusDoc++;
      strcpy(idDocOld,idDoc);
      fscanf(oracleFile,"%s",idDoc);
      
 }
 return numOfCorpusDoc;
}


int loadOracle(struct oracleCell **oracle, char oraclePath[PATH_LENGHT]) {
    
 int numOfCorpusDoc=0,cellIndex=0,
     classIndex,
     numOfClassPerDoc;
 char class[MAX_CLASS_LENGHT];
 char idDoc[ID_DOC_LENGHT];
 char idDocOld[ID_DOC_LENGHT];
 char classes[MAX_CLASS_NUMBER][MAX_CLASS_LENGHT];
 FILE *oracleFile;
 
   if((oracleFile = fopen(oraclePath,"r"))==NULL) {
		printf("Warning : file %s does not found\n",oraclePath);
		return 0;
     }
    else printf("\tfile %s opened\n",oraclePath);  	
 
   numOfCorpusDoc=computeNumberOfCorpusDoc(oracleFile);
   /*TEST printf ("Number of Doc = %d\n",numOfCorpusDoc);*/
   (*oracle) = (struct oracleCell *) malloc(numOfCorpusDoc * sizeof(struct oracleCell));
   rewind(oracleFile);
   
   fscanf(oracleFile,"%s",idDoc);
   /*TEST printf ("idDoc %s\n",idDoc);*/
   while(!feof(oracleFile)){
      strcpy((*oracle)[cellIndex].idDoc,idDoc);
      numOfClassPerDoc=0;
      strcpy(idDocOld,idDoc);	   
      while(!feof(oracleFile) && strcmp(idDoc,idDocOld)==0){
	      fscanf(oracleFile,"%s\n",class);
	      /*TEST printf ("class %s\n",class);*/
	      strcpy(classes[numOfClassPerDoc],class);
	      numOfClassPerDoc++;
	      fscanf(oracleFile,"%s",idDoc);
	      /*TEST printf ("idDoc %s\n",idDoc);*/
      }
      (*oracle)[cellIndex].targetClass=(char **)malloc((numOfClassPerDoc+1)*sizeof(char *));
      (*oracle)[cellIndex].targetClass[numOfClassPerDoc]=NULL;
      for(classIndex=0;classIndex<numOfClassPerDoc;classIndex++)
	  (*oracle)[cellIndex].targetClass[classIndex]=strdup(classes[classIndex]);
      cellIndex++;
   }
   /*TEST  printf ("stampa oracolo \n");
   for(cellIndex=0;cellIndex<numOfCorpusDoc;cellIndex++){
	    classIndex=0;
	    printf("Document id: %s belong to: ",(*oracle)[cellIndex].idDoc);
	    while((*oracle)[cellIndex].targetClass[classIndex]!=NULL){
		    printf("%s\t",(*oracle)[cellIndex].targetClass[classIndex]);
		    classIndex++;
	    }
	    printf("\n");
   }*/	    
	  
   fclose(oracleFile);
		   
   return numOfCorpusDoc;
}  
	    	
		
char *docClassName (char *docName,char *className)
{
 int i=0;
  
 while((docName[i]>'9' || docName[i]<'0')&& i<strlen(docName))
   className[i]=docName[i++];
 className[i]='\0';
 return className;
} 

void docClassNumber (char *docName,char *className)

{
 int i=0,numberStart=0;
 while((docName[i]>'9' || docName[i]<'0')&& i<strlen(docName))i++;
 numberStart=i;
 while((docName[i]<='9' && docName[i]>='0')&& i<strlen(docName))
   className[i-numberStart]=docName[i++];
 className[i-numberStart]='\0';
} 
 
int searchIdDoc(char *idDoc,struct oracleCell *oracle,int i, int j)
{
 if(i>j)return -1;
   else
    if(strcmp((char *)oracle[i+(j-i)/2].idDoc,idDoc)==0) return i+(j-i)/2;
      else 
       if(strcmp((char *)oracle[i+(j-i)/2].idDoc,idDoc)<0)
       	 return searchIdDoc(idDoc,oracle,i+(j-i)/2+1,j);
       else
       	 return searchIdDoc(idDoc,oracle,i,i+(j-i)/2-1);
 }
 


/*********************************************************************************************/
/* 					KNN CODE	   				     */
/*********************************************************************************************/

void shutdownDB(struct docDB *db, int numberOfDoc){

 int i,j;
 	
   for(i=0;i<numberOfDoc;i++)
   {
	for(j=0; j < db[i].size;j++)
	{   
	   MYfree(db[j].docCentroid[i].term);
   	}
	MYfree(db[i].docCentroid);
   }
   
   MYfree(db);
}  
  
 
float documentScalarProduct(struct docVect *docCentroid1, int centroidSize1,
			     struct docVect *docCentroid2, int centroidSize2) {
  int indTermDoc1,
      indTermDoc2,
      confront;
 	  
  double documentTermWeight1,
	 documentTermWeight2,
	 scalarProduct=0,
	 docNorma1=0,
  	 docNorma2=0;
  
    /* TEST   
	printf("Centroid Size:%d ",centroidSize2);*/
  
 
  indTermDoc1=0;
  indTermDoc2=0;
  
  while(indTermDoc2<centroidSize2 || indTermDoc1<centroidSize1){   

/* TEST printf ("  Moltiplico Word %s ---> %d \n",docCentroid1[i].term,i);*/
    
    
    if(indTermDoc2>=centroidSize2) confront=-1;
    else
    	if(indTermDoc1>=centroidSize1) confront=1;
    	  else {	
		 
		  confront=strcmp(docCentroid1[indTermDoc1].term,docCentroid2[indTermDoc2].term);
	  	}
    
    
    if(confront==0){
	   
	      
       docNorma1+=(docCentroid1[indTermDoc1].weight * docCentroid1[indTermDoc1].weight);/* Squared Norma of doc1 */
       
       docNorma2+=(docCentroid2[indTermDoc2].weight * docCentroid2[indTermDoc2].weight);
	
       
       
       scalarProduct+=docCentroid1[indTermDoc1].weight*docCentroid2[indTermDoc2].weight; /** setOfCouples.couple[j].weight)*/;
       
       /* TEST  printf ("  term: %s ---> w1 %f w2 %f scalar product %f\n",
		       docCentroid1[indTermDoc1].term,docCentroid1[indTermDoc1].weight,docCentroid2[indTermDoc2].weight
		       ,scalarProduct);*/
       
       indTermDoc1++;
       indTermDoc2++;
    }
    else if (confront<0){
	   
            docNorma1+= docCentroid1[indTermDoc1].weight * docCentroid1[indTermDoc1].weight;
	    indTermDoc1++;
	    
         }
	 else if (confront>0){
		
       	    docNorma2+=(docCentroid2[indTermDoc2].weight * docCentroid2[indTermDoc2].weight);
	    indTermDoc2++;
	    
         }
	
  }
     	
/* printf ("  documentTermWeight1,documentTermWeight2 %f, %f\n",documentTermWeight1,documentTermWeight2 ); 
printf (" scalarProduct  %f \n",scalarProduct);*/

	/*weightNorma[setOfCouples.couple[j].centroidNumber]+=
		     	  (setOfCouples.couple[j].weight * setOfCouples.couple[j].weight);*/

  
    /* Normalizzation of scalar product   */
     if(scalarProduct!=0) scalarProduct/=sqrt(docNorma1*docNorma2);
     
     /*TEST printf ("  docNorma1,docNorma2 %f, %f\n",docNorma1,docNorma2 );*/
     
    
     return scalarProduct;
}

float maxVect(float *vect, int n){
 int i,
     indMax;
 float max=0;
 
 for(i=0;i<n;i++)
	 if(max<=vect[i]){max=vect[i];indMax=i;}
 vect[indMax]=-1;
 return max;
 }	 

 
 float minVect(float *vect, int n){
 int i,
     indMin;
 float min=0;
 
 for(i=0;i<n;i++)
	 if(min<=vect[i]&&min>=0){min=vect[i];indMin=i;}
 vect[indMin]=-1;
 return min;
 }	 
	 
	 

/*void evaluation(struct numericCluster *clusters[], struct docDB *db, 
		   int numberOfClusters, struct oracleCell *oracle, int numOfDoc){
     struct numericCluster *temp;
     int 
	 idDocPos,
	 classIndex,
	 clusterIndex,
	 labelIndex,
	 counters[3][10],
	 som;

     
     char clusterName[3][20]={"ship","coffee","rice"};
     
     
     
     for(clusterIndex=0;clusterIndex<3;clusterIndex++)
	     for(classIndex=0;classIndex<3;classIndex++)counters[clusterIndex][classIndex]=0;
     
     for(clusterIndex=0;clusterIndex<numberOfClusters;clusterIndex++){
	printf("Cluster %d\n",clusterIndex);
	temp=clusters[clusterIndex];
    	while(temp!=NULL){
	    idDocPos=searchIdDoc(db[temp->docNum].docId,oracle,0,numOfDoc-1);
	    printf("%s:",db[temp->docNum].docId);
	    labelIndex=0;
	    if(idDocPos>=0)
	    while(oracle[idDocPos].targetClass[labelIndex]!=NULL){
			printf("%s ",oracle[idDocPos].targetClass[labelIndex]);
		    for(classIndex=0;classIndex<3;classIndex++)
		       if(strcmp(oracle[idDocPos].targetClass[labelIndex],clusterName[classIndex])==0)
				counters[clusterIndex][classIndex]++;
		    labelIndex++;
	    }
	    printf("\n");
	    temp=temp->next;
     	}
	 printf("\n\n");
     }
     printf("\n\nAccuracy COMPUTATION\n\n");
     for(clusterIndex=0;clusterIndex<3;clusterIndex++){
	     som=0;
	     for(classIndex=0;classIndex<3;classIndex++)som+=counters[clusterIndex][classIndex];
	     printf("cluster %s: %f\n",clusterName[clusterIndex],
			     (float)counters[clusterIndex][clusterIndex]/(float)som);
     }     
			     		     
}

*/

		
/*********************************************** MARIO & EMILIANO ********************************/		
		

/*int insertion_sort(elemento **testa, float product1)
{
	elemento *appo, *appo_prev, *appo_curr; 
	appo_prev = appo_curr = NULL;
	
*/
	/*****************CREAZIONE OGGETTO DELLA LISTA ***************************/ 	
	/*appo = (elemento *)malloc(sizeof(elemento));	
	if (appo == NULL)
		return -1;
	appo->prod = product1;
	appo->succ = NULL;*/
	/***************************************************************************/		
	
	/*if (*testa == NULL)
		{
		 
			*testa = appo;			 		 
		}
	else
		{		
			appo_curr = *testa;
			while(appo_curr != NULL)
			{
				if (product1 >= (appo_curr->prod))
				{
					if (appo_prev == NULL)
					{
						
						appo->succ = *testa;
						*testa = appo;
						break; 
					}
					else 
					{	
						
						appo->succ = appo_curr;
						appo_prev->succ = appo;
						break;						
					}
				}
				appo_prev = appo_curr;
				appo_curr = appo_curr->succ;				
				if (appo_curr == NULL)
				{	
					
					appo_prev->succ = appo;					
					break;
				}				
			}
		}

return 1;
}*/

int inserisci(char *categorie1[NUM_CAT], float product1)
{
        int j, i, contr;
        for ( i = 0; (strcmp(categorie1[i],"-1") != 0) ; i++)
        {
                for(j = 0 ; (strcmp(categorie1[i],rel[j].categoria) != 0) ; j++);
                contr = insertion_sort(&(rel[j].testa),product1);
		if ( contr == -1)
		{
			printf("\n errore \n");
			return -1;
		}
        }
	return 1;

}


/*void distruggi(elemento* testa)
{
	elemento * appo_testa, *appo_succ; 
	appo_testa = testa;
	
	while ( appo_testa != NULL)
	{
		appo_succ = appo_testa->succ;	
		free(appo_testa);
		appo_testa = appo_succ;
	} 
}*/

float calcola_media(elemento *appo, int k)
{
	float media = 0.0;
	int i;
	elemento *appo1 = appo;
	for(i = 0 ; i < k ; i++)
	{
		if (appo1 == NULL) break;
		media += appo1->prod;
		appo1 = appo1->succ;
	}
	
	media /= i;
	return media;
}


void cerca_massimo(elemento_ris *risultati, int h)
{
	float max1, max2;
	int j1,j2,i;
	
	
	j1 = j2 = 0;
	max1 = rel[0].media[h];
	max2 = 0;

	for (i = 1; strcmp(rel[i].categoria," ") != 0 ; i++)
	{
		if (rel[i].media[h] > max1)
		{
			max2 = max1;
			j2 = j1;
			max1 = rel[i].media[h];
			j1 = i;
			
		}
		else if (rel[i].media[h] > max2)
			{
				max2 = rel[i].media[h];
				j2 = i;
			}		
	}
		
		
	(*risultati).categoria1 = (char *) malloc(sizeof(char)*40);
	(*risultati).categoria2 = (char *) malloc(sizeof(char)*40);
	strcpy((*risultati).categoria1, rel[j1].categoria);
	strcpy((*risultati).categoria2, rel[j2].categoria);
}


void inizializza(void)
{
	int i, j;
	
	for(i = 0; i<NUM_CAT; i++)
	{
		distruggi(rel[i].testa);
		rel[i].testa = NULL;
		for (j = 0; j < 13; j++)
			rel[i].media[j] = 0.0 ;
		strcpy(rel[i].categoria," ");
	}
}


void ins_cat(char * categorie[NUM_CAT])
{
	int i,j,trovato;
	char c;
	
	for(i = 0 ; ((strcmp(categorie[i],"-1") != 0)) ; i++)
	{
		trovato = 0;
		for(j = 0 ; ((strcmp(rel[j].categoria," ") != 0)) ; j++)
		{
			if (strcmp(rel[j].categoria,categorie[i]) == 0)
			{
				trovato = 1;
				break;
			}
		}
		if (trovato != 1) 
		{
			strcpy(rel[j].categoria, categorie[i]);
				
		}
	}
}


void inizializza_cat(char * categorie1[NUM_CAT]	)
{
	int i;
	for(i= 0; i < NUM_CAT; i++)
	{
		free(categorie1[i]);
		categorie1[i] = (char *) malloc(sizeof(char)*40);
	}
}

void performance(elemento_ris risultato1[MAX_DOCS_TEST], struct oracleCell *oracle1, int numberOfDoc, int k)
{
	int i, j, t, a, b, c, a1, h;
	float prec, rec, count;
	FILE *perf;
	
	a1 = b = c = 0;
	h = 1;
	count = 0.0;
	
	for( i = 0 ; i < numberOfDoc ; i++)
	{
		a = 0;
		j = 0;
		while (strcmp(risultato1[i].Iddoc, (oracle1)[j].idDoc) != 0)
			j++;
		
		
		for (t = 0 ; (oracle1)[j].targetClass[t] != NULL ; t++)
		{
			if (strcmp(risultato1[i].categoria1, (oracle1)[j].targetClass[t]) == 0)
			{
				a++;
			}
		}
		
		if (count > 1)	
		{
			for (t = 0 ; (oracle1)[j].targetClass[t] != NULL ; t++)	
			{
				if (strcmp(risultato1[i].categoria2, (oracle1)[j].targetClass[t]) == 0)
			 		a++;		
			}
			
			h = 2;
				
			count--;
		}	
		
		b += (h - a);
		
		a1 += a;
		
		if ( t > h) c += (t-h);
		
		h = 1;
		
		count += 0.0;
	}

	prec = ((float)a1)/(float)(a1 + b);
	rec = ((float)a1)/(float)(a1 + c);

	printf("a : %d, b : %d, c: %d", a1, b, c); 
	
	perf = fopen("performance", "at");
	fprintf(perf,"Per K = %d : Precision = %f ,  Recall = %f\n",k, prec, rec);
	fclose(perf);
}
			

void KNN_classifier (struct clustering_env my_env, char *extension)
{ 
  char className [PATH_LENGHT];
  char trainingFileAbsName[PATH_LENGHT];
  char testingFileAbsName[PATH_LENGHT];
  struct CKB_env my_CKB_env;
  
  struct docVect docCentroid[MAX_DOC_SIZE];
  int 	 centroidSize;
  
  FILE *trainingFile, *testingFile, *perf,*trainingFileSVM;
  int numberOfDoc1;
  int numberOfDoc2;
  
  char 	docId[PATH_LENGHT];
  
  
  char 	temp[PATH_LENGHT],
	command[PATH_LENGHT];
  
  long pos; /*position of class file pointer */
    
  int centroidSizes;

  int binaryWeight;

  int previous=-1; /* previous offset */

  struct docDB *db_training, *db_testing;
  int docIndex;

  struct oracleCell *oracle;
  int numOfCorpusDoc;

  float product;
  float sommQuad;
  int contr = 0, q = 0, i, j, classIndex, t, k = 30, l, y;
  int count, luck,nerror,
      index; 
  char *categorie[NUM_CAT];
  /*char *cat[MAX_DOCS_TEST];*/
  

  elemento * appo;
     
  /* -------------------------------------------- */
  /*    Load the classification Knowledge Bases   */
  /* -------------------------------------------- */

   loadClassificationKB(my_env,extension,&my_CKB_env);
    
  /* -------------------------------------------- */
  /*    Load the set of training documents		  */
  /* -------------------------------------------- */
  
  sprintf(trainingFileAbsName,"training");
    if((trainingFile = fopen(trainingFileAbsName,"r"))==NULL) {
	     printf("ERROR : file %s to be clustered does not found\n",trainingFileAbsName);
	     exit(-1);
    }
   
  
  /* count the document with the function for load a single doc */

  /* Per i documenti di training: crea la struttura db_training */
    
    pos=0; strcpy(docId,"");
  
  
   
    if((trainingFileSVM = fopen("SVM_trainingFile","w"))==NULL) {
	     printf("ERROR : file %s to be clustered does not found\n","SVM_trainingFile");
	     exit(-1);
    }
    
      sprintf(trainingFileAbsName,"training");
    if((trainingFile = fopen(trainingFileAbsName,"r"))==NULL) {
	     printf("ERROR : file %s to be clustered does not found\n",trainingFileAbsName);
	     exit(-1);
    }
  
  while(!feof(trainingFile)){

	centroidSizes=
	buildExtractedDocumentCentroid(trainingFile,docCentroid,&pos,docId,my_CKB_env);	
	sommQuad=0;nerror=0;
	/*printf("doc %s size: %d\n",docId,centroidSizes);*/	

	fprintf(trainingFileSVM,"%s\t",docId);

	/* compute norma and look for a parse tree feature*/

	for(index=0;index<centroidSizes;index++){

//	  printf("documentId %s term %s weigth %f\n",docId,docCentroid[index].term,docCentroid[index].weight);
//	  fflush(stdout);

	  if(docCentroid[index].weight!=-1)sommQuad+=(docCentroid[index].weight)*(docCentroid[index].weight);
	  else fprintf(trainingFileSVM,"%s |STD| ",docCentroid[index].term);
}
	sommQuad= sqrt(sommQuad);
	previous=-1;

	for(index=0;index<centroidSizes;index++)
	   if((docCentroid[index].offset)==previous-1)
	   	printf("%d:Warning an error has occured in aggregating features: (offset=%d)\n",
			++nerror, docCentroid[index].offset);
	   else{
	    /*if(docCentroid[index].weight/sommQuad>0)binaryWeight=1;
	    else binaryWeight=0;
	    fprintf(trainingFileSVM,"%d:%f ",(previous=++(docCentroid[index].offset)),(float) binaryWeight);
	    */
	    	if(docCentroid[index].weight!=-1)
		  if(strcmp(my_env.weighting,"YES")==0) 
		  	fprintf(trainingFileSVM,"%d:%f ",(previous=++(docCentroid[index].offset)),docCentroid[index].weight/sommQuad);
		  else
			fprintf(trainingFileSVM,"%d:1 ",(previous=++(docCentroid[index].offset)));
	  }	
	
	    fprintf(trainingFileSVM,"\n");
	numberOfDoc1++;
	
	
  }  

}

void KNN(struct clustering_env my_env, int classId) 
  {
   int i,
       classNumber,
       NumberOfClasses;
   float		   
	threshold[MAX_CLASS_NUMBER];
   float RP_Difference;
		
   struct results perClassPR[MAX_CLASS_NUMBER];
   short finish;
   int count;
   char  learningType[4];

      /* show the environment*/
   if (my_env.verbose_switch==ON) {
   printf("       dict_path = %s\n",my_env.dict_path);
   printf("       output_path = %s\n",my_env.output_path);
   printf("       out_clusters_path = %s\n",my_env.out_clusters_path);
   printf("       in_clusters_path = %s\n",my_env.in_clusters_path);
   printf("       tmp_path = %s\n\n",my_env.tmp_path);
   printf("       class path to be clustered (splitted_class_path) = %s\n\n",
		   my_env.splitted_class_path);
   
   
   
   printf("      verbose_switch = %s\n\n",(my_env.verbose_switch==ON?"ON":"OFF"));
   
   printf("           le_switch = %s\n",(my_env.le_switch==ON?"ON":"OFF"));
   printf("           ne_switch = %s\n",(my_env.ne_switch==ON?"ON":"OFF"));
   printf("           ev_switch = %s\n\n",(my_env.ev_switch==ON?"ON":"OFF"));
   
   printf("     number of clusters required = %d\n\n",my_env.numberOfClusters);
   
   
  
   } 
   
   if (my_env.le_switch==ON)strcpy(learningType,"le");
   if (my_env.ne_switch==ON)strcpy(learningType,"ne");
   if (my_env.ev_switch==ON)strcpy(learningType,"ev");
   
   KNN_classifier(my_env,learningType);
}
