/***********************************************************************/
/*   Text Categorization Framework                                     */
/*                                                                     */
/*                                                                     */
/*   Author: Alessandro Moschitti                                      */
/*   moschitti@info.uniroma2.it                                        */
/*   Date: 30.11.03                                                    */
/*                                                                     */
/*   Copyright (c) 2003  Alessandro Moschitti - All rights reserved    */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/


#include <stdio.h>
#include <string.h>

typedef struct elemento_appo
   {
    float prod;
    struct elemento_appo *succ;
   }elemento;


int insertion_sort(elemento **testa, float product1)
{
	elemento *appo, *appo_prev, *appo_curr; 
	appo_prev = appo_curr = NULL;
	/*printf(" \n 5.1 \n ");*/

	/*****************CREAZIONE OGGETTO DELLA LISTA ***************************/ 	
	appo = (elemento *)malloc(sizeof(elemento));	
	if (appo == NULL)
		return -1;
	appo->prod = product1;
	appo->succ = NULL;
	/***************************************************************************/		
	
	if (*testa == NULL)
		{
		/* printf(" \n 5.4 primo inserimento testa \n "); */ 
			*testa = appo;			 		 
		}
	else
		{		
			appo_curr = *testa;
			while(appo_curr != NULL)
			{
				if (product1 >= (appo_curr->prod))
				{
					if (appo_prev == NULL)
					{
						/*printf(" \n 5.4 inserimento testa \n ");*/
						appo->succ = *testa;
						*testa = appo;
						break; 
					}
					else 
					{	
						/*printf(" \n 5.4 inserimento corpo \n ");*/
						appo->succ = appo_curr;
						appo_prev->succ = appo;
						break;						
					}
				}
				appo_prev = appo_curr;
				appo_curr = appo_curr->succ;				
				if (appo_curr == NULL)
				{	
					/*printf(" \n 5.4 inserimento coda \n ");*/
					appo_prev->succ = appo;					
					break;
				}				
			}
		}
/*printf(" \n 5.2.1 \n ");*/
return 1;
}


void distruggi(elemento* testa)
{
	elemento * appo_testa, *appo_succ; 
	appo_testa = testa;
	
	while ( appo_testa != NULL)
	{
		appo_succ = appo_testa->succ;	
		free(appo_testa);
		appo_testa = appo_succ;
	} 
}
