#include "classifier.h"
#include "base_lib.h"


void task1(struct class_ce_env my_env,int whichClass,char *extension)
{
  char classFileName[PATH_LENGHT];
  char centroidFileName[PATH_LENGHT];
  char orderedCentroidFileName[PATH_LENGHT];
  
  char sortcommand[200],
       erasecommand[200];
  
  if (my_env.verbose_switch==ON) 
    printf("\nBuild centroid for class '%s' using '%s' information\n\n",my_env.class_names[whichClass],extension);

  classSplitting(my_env,whichClass,extension);          

  sprintf(classFileName,"%s/%s.%s",my_env.splitted_class_path,my_env.class_names[whichClass],extension);

  sprintf(centroidFileName,"%s/%s.%s.ce",my_env.tmp_path,my_env.class_names[whichClass],extension);

  if (my_env.verbose_switch==ON) printf("     Learning data file=%s\n",classFileName);
      
  if (buildCentroidForClass(my_env,classFileName,centroidFileName)==0 )
	return; /*the class file does not exist*/
  if (my_env.verbose_switch==ON) printf("          Centroid file=%s written\n",centroidFileName);
  
  /* sort centroid on file */
      
  sprintf(orderedCentroidFileName,"%s/%s.%s.oce",my_env.centroid_path,my_env.class_names[whichClass],extension);

  sprintf(sortcommand,"sort -o %s %s",orderedCentroidFileName,centroidFileName);

  if(system(sortcommand)==0) {
       sprintf(erasecommand,"rm %s",centroidFileName);
       system(erasecommand);
  } else 
       if (my_env.verbose_switch==ON)  
	  printf("\nWarning : Centroid %s was not ordered therefore it did not be removed %s\n",centroidFileName);

  /* non si cancellano piu' le classi splittateif (my_env.test_set_percentage!=0){
       sprintf(erasecommand,"rm %s",classFileName);
        system(erasecommand);
  }*/

  if (my_env.verbose_switch==ON) printf("  Ordered Centroid file=%s written\n",orderedCentroidFileName);
}


int buildCentroidForClass(struct class_ce_env my_env, char *classFileName,char *centroidFileName)
 {	 
  
  struct pair ce[80000];

  char term[FREAD_BUFFER_SIZE];
  char syntClass[SYNTATCTIC_CLASS_DIGIT];
  int freq;
  char stopListFileName[PATH_LENGHT];     
  char documentId[TERM_LENGHT];
  int i;
  int n;
  int numberOfSW;
  FILE *f1;
  
  n=0;
  
  /*TEST*/ printf("\n file %s opening...\n\n",classFileName);
  if((f1=fopen(classFileName,"r"))==NULL) {
   if (my_env.verbose_switch==ON)printf("   Warning : file %s does not found\n",classFileName);
      return 0;
  }
  /* you can use the input file f1 */
  fscanf(f1,"%s",documentId);n=0;strcpy(ce[n].lastDocId,"");
  while(!feof(f1)) {    
	  
     fscanf(f1,"%s",term);
     fscanf(f1,"%d\n",&freq);
     for(i=0;i<n;i++)
        if (strcmp(term,ce[i].item)==0) {
            /*TEST printf("key %s already present\n",term);*/
            ce[i].freq+=freq;
	    if(strcmp(documentId,ce[i].lastDocId)!=0){
	      ce[i].count++;
	      strcpy(ce[i].lastDocId,documentId);
      	    }  
	    i=n+1;
        }
     if(i==n){
          /*TEST printf("key %s added at the end\n",term);*/
	  ce[n].item = MYstrdup(term);     
          ce[n].freq=freq;
	  ce[n].count=1;strcpy(ce[n].lastDocId,documentId);
          n++;
     }
     fscanf(f1,"%s",documentId);
  }
  fclose(f1);
     
  /* write centroid on file */
  if((f1=fopen(centroidFileName,"w"))==NULL)
  {
     if (my_env.verbose_switch==ON) printf("   Error : file %s write permission denied\n",centroidFileName);
     return 0;
  }
  /* you can use the output file f1 */
  for(i=0;i<n;i++)
  {
    fprintf(f1,"%s\t",ce[i].item);
    fprintf(f1,"%d\t",ce[i].freq);
    fprintf(f1,"%d\n",ce[i].count);
    MYfree(ce[i].item);
  }
  fclose(f1);
  return 1;
}

void ClassCentroidProcessing(struct class_ce_env my_env) 
{
   int whichClass;

   if (my_env.verbose_switch==ON) {
     /* show the environment */
     int i;
     printf("----------------------------------------------------\n\n");
     
     printf("          class_path = %s\n",my_env.class_path);
     printf("       centroid_path = %s\n",my_env.centroid_path);
     printf("       tmp_file_path = %s\n\n",my_env.tmp_path);
   
     printf("      verbose_switch = %s\n\n",(my_env.verbose_switch==ON?"ON":"OFF"));
   
     printf("           le_switch = %s\n",(my_env.le_switch==ON?"ON":"OFF"));
     printf("           ne_switch = %s\n",(my_env.ne_switch==ON?"ON":"OFF"));
     printf("           ev_switch = %s\n\n",(my_env.ev_switch==ON?"ON":"OFF"));
   
     printf(" test_set_percentage = %d\n",my_env.test_set_percentage);
     printf("       test_doc_path = %s\n\n",my_env.test_doc_path);
     
     printf("        class_number = %d\n\n",my_env.class_number);
     for (i=0; i<my_env.class_number ; i++)
       printf("   class_names[%d] = %s\n",i,my_env.class_names[i]);
     
     printf("\n----------------------------------------------------\n\n");
  }
  for(whichClass=0;whichClass<my_env.class_number;whichClass++) {
    if (my_env.le_switch==ON)
      task1( my_env,whichClass,"le");
    if (my_env.ne_switch==ON)
      task1( my_env,whichClass,"ne");
    if (my_env.ev_switch==ON)
      task1( my_env,whichClass,"ev");
  }
}
/* end */
