/***********************************************************************/
/*   Text Categorization Framework                                     */
/*                                                                     */
/*                                                                     */
/*   Author: Alessandro Moschitti                                      */
/*   moschitti@info.uniroma2.it                                        */
/*   Date: 30.11.03                                                    */
/*                                                                     */
/*   Copyright (c) 2003  Alessandro Moschitti - All rights reserved    */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/


#include "classifier.h"

task2e3(struct global_ce_env my_env,char *extension)
{  
 
 
 FILE	*fileGlobalCen,*fileDict;
 
 struct centroid centroids[MAX_CLASS_NUMBER];

 
 int isUpdated=1, 	/* is 1 if at least a term was written in Global Centroiod*/
     totalTermNumber=0, /*the Number of Corpus terms with frequency included*/ 		 
     centroidNumber,
     i,j,n;
 
 char globalCentroidAbsName[PATH_LENGHT],
      DictAbsName[PATH_LENGHT];
     
  
  if (my_env.verbose_switch==ON) 
    printf("\nBuild global centroid relative to %s infromation from centroids: \n\n",extension);

   centroidNumber=openAllCentroids(my_env.centroid_path,my_env.centroid_names,my_env.centroid_number,my_env.verbose_switch,
		centroids,extension,NULL);
   
   sprintf(globalCentroidAbsName,"%s/%s.%s",my_env.global_centroid_path,GLOBAL_CENTROID,extension);

   fileGlobalCen = fopen(globalCentroidAbsName,"w");
   if(fileGlobalCen==NULL)
    {
      if (my_env.verbose_switch==ON) 
      printf("file %s write permission denied\n",globalCentroidAbsName);
      exit(-1);
    }
    
       
   sprintf(DictAbsName,"%s/%s.%s",my_env.global_centroid_path,OFFSET_DICTIONARY);
   fileDict = fopen(DictAbsName,"w");   
   if(fileDict==NULL)
    {
      if (my_env.verbose_switch==ON)     
      printf("file %s write permission denied\n",DictAbsName);
      exit(-1);
    }
   
   initStatusOfCentroids(centroids,centroidNumber);
   n=0;
   
   while(isUpdated)
     {
      isUpdated=0;
      updateCurrentElementOfCentroids(centroids,centroidNumber);
      findMinElementOfCentroids(centroids,centroidNumber);    
      isUpdated=mergeInGlobalCentroid(fileGlobalCen,fileDict,centroids,centroidNumber,&totalTermNumber);
     }
     
   fclose(fileGlobalCen);
   fclose(fileDict);
   if (my_env.verbose_switch==ON) 
      {
       printf("\n %s written\n",globalCentroidAbsName);
       printf("\n %s written\n",DictAbsName);
      }
   closeAllCentroidFiles(centroids,centroidNumber);
}  
        

void GlobalCentroidProcessing(struct global_ce_env my_env) 
{
   if (my_env.verbose_switch==ON) {
   int i;
   /* show the environment */
   printf("       centroid_path = %s\n",my_env.centroid_path);
   printf("       tmp_file_path = %s\n\n",my_env.tmp_path);
   
   printf("      verbose_switch = %s\n\n",(my_env.verbose_switch==ON?"ON":"OFF"));
   
   printf("           le_switch = %s\n",(my_env.le_switch==ON?"ON":"OFF"));
   printf("           ne_switch = %s\n",(my_env.ne_switch==ON?"ON":"OFF"));
   printf("           ev_switch = %s\n\n",(my_env.ev_switch==ON?"ON":"OFF"));
   
   printf("     centroid_number = %d\n\n",my_env.centroid_number);
   for (i=0; i<my_env.centroid_number ; i++)
     printf("     centroid_names[%d] = %s\n",i,my_env.centroid_names[i]);
   }
    if (my_env.le_switch==ON)
      task2e3(my_env,"le");
    if (my_env.ne_switch==ON)
      task2e3(my_env,"ne");
    if (my_env.ev_switch==ON)
      task2e3(my_env,"ev");
}  
