/***********************************************************************/
/*   Text Categorization Framework                                     */
/*                                                                     */
/*                                                                     */
/*   Author: Alessandro Moschitti                                      */
/*   moschitti@info.uniroma2.it                                        */
/*   Date: 30.11.03                                                    */
/*                                                                     */
/*   Copyright (c) 2003  Alessandro Moschitti - All rights reserved    */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/


#include "classifier.h"
#include <math.h>
#include <string.h>

/**********************************************************************************************
* 					Program OPTION					      *
***********************************************************************************************/

/*


#define SCUT
#undef RDS*/

#define SCUT
#undef RDS
#undef COMBINED_SCUT_RDS

/*#undef OUTPUT_STDSCARTI*/
#define OUTPUT_STDSCARTI
#define MAX_CICLE_NUMBER 25

int n=0;
/*********************************************************************************************/
/***				Heading of PROCEDURES					  ****/
/*********************************************************************************************/

void takeAdecisionRanking(float a[], struct CKB_env *clKB, float percentRank, short d[], float *remain);
void aProduct (char *termine, int freq, struct CKB_env *clKB, float *scalarProducts, double *docNorma,int
		*numOfOtherClass);
void takeAdecision(float a[],struct CKB_env *clKB,float threshold[],short d[]);
int task5(struct classifier_env my_env, char *extension, float threshold[], 
		struct results *perClassPR);




int loadClassificationKB(struct classifier_env my_env,char *extension,struct CKB_env *clKB) {
  char etichetta[TERM_LENGHT];
  char dictAbsName[PATH_LENGHT];
  char weightDictAbsName[PATH_LENGHT];
  char infoDictionariesAbsName[PATH_LENGHT];
  int i=0;

    
  FILE *infoDictionariesFile;
  FILE *offsetDictFile;
  FILE *weightDictFile;
   
  /* -------------------------------- */
  /* Reading Dictionaries information */
  /* -------------------------------- */
  if (my_env.verbose_switch==ON) printf ("Reading Dictionaries information\n");
  sprintf(infoDictionariesAbsName,"%s/%s.%s",my_env.dict_path,INFO_DICTIONARY,extension);
  if((infoDictionariesFile = fopen(infoDictionariesAbsName,"r"))==NULL) {
      printf("file %s does not found\n",infoDictionariesAbsName);
      return 0;
  }
  fscanf(infoDictionariesFile,"%s\n%d\n%s\n%d\n",
		              etichetta,&(clKB->totalDocumentNumber),
		              etichetta,&(clKB->differentWordNumber));
  clKB->centroidNumber=0;
  
    /* Centroid Names reading */

  fscanf(infoDictionariesFile,"%s\n",clKB->centroidNames[clKB->centroidNumber]);
  while(!feof(infoDictionariesFile)&& strcmp(clKB->centroidNames[clKB->centroidNumber],"Max_Weight=")!=0){
    if (my_env.verbose_switch==ON) 
	   printf("centroidNames[%d]=%s\n",clKB->centroidNumber,clKB->centroidNames[clKB->centroidNumber]);
    clKB->centroidNumber++;
    fscanf(infoDictionariesFile,"%s\n",clKB->centroidNames[clKB->centroidNumber]);
  }
  
  fscanf(infoDictionariesFile,"%f\n%s",&(clKB->maxWeight),etichetta);  /* max weight reading */
  
    /* Centroid total Frequences reading */
  i=0;
  fscanf(infoDictionariesFile,"%f\n",&clKB->centroidTotalFreqs[i]);
  while(!feof(infoDictionariesFile)&&i<clKB->centroidNumber){	  
    if (my_env.verbose_switch==ON) 
	   printf("centroidTotalFreq[%d]=%f\n",i,clKB->centroidTotalFreqs[i]);
    i++;
    fscanf(infoDictionariesFile,"%f\n",&clKB->centroidTotalFreqs[i]);
  }
  
  
    /* Average, STD Deviation reading (of positive) */
  i=0;
  fscanf(infoDictionariesFile,"%s%f\n",etichetta,&clKB->positiv[i].average);
  while(!feof(infoDictionariesFile)&&i<clKB->centroidNumber){
    fscanf(infoDictionariesFile,"%f\n",&clKB->positiv[i].stdDeviation);	  
    if (my_env.verbose_switch==ON){
	   printf("positiv[%d].average=%f\t",i,clKB->positiv[i].average);
	   printf("positiv[%d].stdDeviation=%f\n",i,clKB->positiv[i].stdDeviation);
    }
    fscanf(infoDictionariesFile,"%f\n",&clKB->positiv[++i].average);
  }
  
    /* Average, STD Deviation reading of negative */
  i=0;
  fscanf(infoDictionariesFile,"%s%f\n",etichetta,&clKB->negativ[i].average);
  while(!feof(infoDictionariesFile)&&i<clKB->centroidNumber){
    fscanf(infoDictionariesFile,"%f\n",&clKB->negativ[i].stdDeviation);	  
    if (my_env.verbose_switch==ON){
	   printf("negativ[%d].average=%f\t",i,clKB->negativ[i].average);
	   printf("negativ[%d].stdDeviation=%f\n",i,clKB->negativ[i].stdDeviation);
    }
    fscanf(infoDictionariesFile,"%f\n",&clKB->negativ[++i].average);
  }
  
  fclose(infoDictionariesFile);
  
  
  /* -------------------------------- */
  /* Reading dictionaryOffset 	      */
  /* -------------------------------- */

  sprintf(dictAbsName,"%s/%s.%s",my_env.dict_path,OFFSET_DICTIONARY,extension);
  if((offsetDictFile = fopen(dictAbsName,"r"))==NULL) {
      printf("file %s does not found\n",dictAbsName);
      return 0;
  }
  sprintf(weightDictAbsName,"%s/%s.%s",my_env.dict_path,WEIGHT_DICTIONARY,extension);
  if((clKB->weightDictFile = fopen(weightDictAbsName,"r"))==NULL) {
      printf("file %s does not found\n",weightDictAbsName);
      return 0;
  }

  if (my_env.verbose_switch==ON) printf ("loading Offset Dictionary ... "); 
  loadDictionaryOffset(offsetDictFile,clKB->differentWordNumber,&clKB->offsetDictArray);
  if (my_env.verbose_switch==ON) printf ("done !\n");    

  fclose(offsetDictFile);
  
  }

short sgn(float x){
	if(x>=0) return 1;
	else return -1;
 }
  
int unifieLemma(char *term, int freq, struct dictionary *centroid, int centroidSize){
  
  int i;
       for(i=0;i<centroidSize;i++)
	  if (strcmp(term,centroid[i].term)==0) {
              /*TEST printf("key %s already present\n",term);*/
              centroid[i].freq+=freq;
	      i=centroidSize+2;
	  }  
       if(i<centroidSize+2){
               /*TEST printf("key %s added at the end\n",term);*/
	       
	       strcpy(centroid[centroidSize].term,term);     
               centroid[centroidSize].freq=freq;
	       centroidSize++;
       }
   return centroidSize;    
   }
    

int buildDocumentCentroid(FILE *documentFile, 
		struct dictionary *docCentroid, char *extension){
	  
   char 
	documentId[TERM_LENGHT],
      	term[TERM_LENGHT];   
   
   char  documentAbsName[PATH_LENGHT];
   
   int freq,centroidSize=0;    
     
	     
     fscanf(documentFile,"%s",documentId);
     while(!feof(documentFile)){    
       fscanf(documentFile,"%s",term);
       fscanf(documentFile,"%d",&freq);
       /*TEST printf("%s\n",documentId);
       printf("%s\n",term);
       printf("%d\n\n",freq);*/ 
              		                
       centroidSize=unifieLemma(term,freq,docCentroid,centroidSize);  
       fscanf(documentFile,"%s",documentId);
    }
       
   return centroidSize; 
        
}  
  

void shutdownClassificationKB(struct CKB_env *clKB){
  int i;
  	
  for(i=0;i<clKB->differentWordNumber;i++)
	  MYfree(clKB->offsetDictArray[i].term);
  
  MYfree(clKB->offsetDictArray);
  fclose(clKB->weightDictFile);
  
}

void shutdownOracle(struct oracleCell *oracle, int numOfdoc){
  int cellIndex,
      classIndex;
  	
  for(cellIndex=0;cellIndex<numOfdoc;cellIndex++){
     classIndex=0;
     while(oracle[cellIndex].targetClass[classIndex]!=NULL){
	  MYfree(oracle[cellIndex].targetClass[classIndex]);
	  classIndex++;
     }
  MYfree(oracle[cellIndex].targetClass);
  }
  MYfree(oracle);
}
    

	   
void aProduct (char *term, int freq, struct CKB_env *clKB, float *scalarProducts, double *docNorma, int *numOfOtherClass) {
      
  int 	j;
   int c=0;
  struct couples setOfCouples;
  int numberOfCouple,count;
 	  
  float documentTermWeight,
 	IDF,
	k;
	   
	   	   
  numberOfCouple =couplesRelativeToTerm(clKB->weightDictFile,term,
			           &setOfCouples,clKB->offsetDictArray,
			           clKB->differentWordNumber); 
  if(numberOfCouple!=0){

     IDF=log(((float)clKB->totalDocumentNumber)/(float)setOfCouples.numOfDocWithCurrentTerm);
/***!!!!
!!!!!
!!!! ATTENZIONE PROVA SENZA IDF**
     
     IDF=1;*/
     
     
     documentTermWeight=ft(freq)*IDF;
     *docNorma+=(documentTermWeight * documentTermWeight);
  
     /* TEST   
     printf("document Norma:%f\n",*docNorma);
     printf("\ntermine = %s, totalDocumentNumber=%d, occuredInDocNumb=%d, IDF=%f,
			   docWeight=%f\n",
	     term,clKB->totalDocumentNumber,setOfCouples.numOfDocWithCurrentTerm,IDF,
			     documentTermWeight);*/
	/* empirically derived parameter*/
     
     
      
	  
     if((term[strlen(term)-4]=='-')&&(term[strlen(term)-3]=='o')){
		     *numOfOtherClass=numberOfCouple;
		     
     }	

          for(j=0;j<numberOfCouple;j++) {

 /*TEST  printf("\n%d",j); */
	     
	     k=1;/*terminologicalWeigth(term);	     */
      	   /*  if(term[strlen(term)-4]=='-' && term[strlen(term)-3]=='t'){
		/*clKB->numOfTermExp[setOfCouples.couple[j].centroidNumber]+= 
				setOfCouples.couple[j].weight*terminologicalWeigth(term)/ *numOfOtherClass;
				/*terminologicalWeigth(term)/((float)numberOfCouple);*/
		
		
		clKB->numOfTermExp[setOfCouples.couple[j].centroidNumber]+=
		terminologicalWeigth(term)/(*numOfOtherClass);
		
		/*printf("%d\t",c++);
		/*TEST printf("\n express: %s %d\n",term,*numOfOtherClass);*/
	/*	if(*numOfOtherClass<2) k =terminologicalWeigth(term);
		/*else k =50*terminologicalWeigth(term)/(*numOfOtherClass);*/
	    /* }*/
	     
	     scalarProducts[setOfCouples.couple[j].centroidNumber]+=
				      (documentTermWeight * setOfCouples.couple[j].weight * k);


 /*weightNorma[setOfCouples.couple[j].centroidNumber]+=
		     	  (setOfCouples.couple[j].weight * setOfCouples.couple[j].weight);*/

 /* TEST  
	 printf("term=%s\tprofile weight:%f\tdocumentTermWeight %f\n",term,setOfCouples.couple[j].weight,documentTermWeight);
	 printf("prodotto alla %d_esima classe:%f\n",setOfCouples.couple[j].centroidNumber,
		       (documentTermWeight * setOfCouples.couple[j].weight));
	 printf("document Norma:%f\n",*docNorma);count++;
	 getchar();*/
     }
   }
 }  


void aDocumentScalarProduct(struct dictionary *docCentroid, int centroidSize, char *extension,
		            struct CKB_env *clKB, float *scalarProducts) {
  int i,
      freq,
      numOfOtherClass=0;
  
  char 	term[PATH_LENGHT];
  
  float  weightNorma[MAX_CLASS_NUMBER];
  double docNorma,prova=0;
  
  
  /* reset scalar product and Norma */
  for(i=0;i<clKB->centroidNumber;i++)
     clKB->numOfTermExp[i]=scalarProducts[i]=weightNorma[i]=0;
  
  docNorma=0;
     /* TEST   
	printf("Centroid Size:%d\n",centroidSize);*/
  for(i=0;i<centroidSize;i++){
    
      strcpy(term,docCentroid[i].term);
      freq=docCentroid[i].freq;
      /*if(((term[strlen(term)-4]=='-')&&(term[strlen(term)-3]=='t'))||
         ((term[strlen(term)-4]=='-')&&(term[strlen(term)-3]=='o'))){
       
        term[strlen(term)-3]='o';
        aProduct(term,freq,clKB,scalarProducts,&docNorma,&numOfOtherClass);	   
        term[strlen(term)-3]='t';
       }
      else numOfOtherClass=0; */
      aProduct(term,freq,clKB,scalarProducts,&docNorma,&numOfOtherClass);   
          
  }
    
  /* Normalizzation of scalar product   */

    /*TEST	  printf("document Norma:%f\t",docNorma);*/

  for(i=0;i<clKB->centroidNumber;i++){
    /*TEST	  printf("prodotto alla %d_esima classe:%f\t",i,
		      scalarProducts[i]);*/
     if(docNorma>0)scalarProducts[i]/=sqrt(docNorma);
     /*TEST	  printf("prodotto alla %d_esima classe:%f\t",i,
		      scalarProducts[i]);*/

  }
    /*TEST printf("count:%d\n",count);*/

}




/*float prob(float sp, int index){
	
	float prob;
	/*float coef[]={1.3579,0.0450,0.7052,0.3140,0.3908,0.3807,0.5862,1.1492,0.6385,0.4475,
		      0.3510,0.2485,0.5047,0.4442,0.6616,0.0835,0.3831,0.2793,0.3350,0.3472};
	
	float constant[]={-13.0158,0.3963,-9.6594,-3.9713,-5.7335,-3.2358,-5.9387,-11.9366,-5.9461,-7.0768,
			  -4.5812,-4.7237,-7.4914,-6.2214,-8.7646,-2.1846,-5.8746,-4.1294,-6.0631,-5.4750};
				
			
	float coef[]={1.3579,0.0450,0.7052,0.3140,0.3908,0.4227,0.5862,1.1492,0.6385,0.4475,
		      0.3510,0.2485,0.5047,0.4442,0.6616,0.0835,0.3831,0.2793,0.3350,0.3472};
	
	float constant[]={-13.0158,0.3963,-9.6594,-3.9713,-5.7335,-4.9646,-5.9387,-11.9366,-5.9461,-7.0768,
			  -4.5812,-4.7237,-7.4914,-6.2214,-8.7646,-2.1846,-5.8746,-4.1294,-6.0631,-5.4750};
	
	float coef[]={1.1413,0.0425,0.7353,0.3507,0.4306,0.4187,0.5779,1.0141,0.6119,0.4802,
		      0.4394,0.2752,0.4741,0.4883,0.7054,0.1109,0.3962,0.2975,0.3501,0.3597};
	
	float
		constant[]={-11.3047,0.3689,-10.0241,-4.2508,-6.1444,-3.4774,-5.8474,-10.6912,-5.7399,-7.4526,
	    		    -5.4697,-4.9118,-7.1803,-6.6771,-9.2519,-2.4946,-6.0350,-4.3340,-6.2836,-5.5163};
	*/
			
/*			
	float coef[]={10.1590,9.5237,4.8287,8.0872,10.3163,8.8164,9.7788,22.7012,7.3569,8.9160,
		      8.0211,10.1990,8.8440,8.2095,8.2577,5.7562,6.7416,8.0319,9.6898,8.6070};
	
	float
		constant[]={-8.0904,-1.5582,-5.2954,-3.7983,-6.7413,-2.9605,-5.6981,-9.5223,-4.9662,-6.4946,
			    -4.6138,-6.2878,-7.2238,-5.2493,-8.1264,-3.5602,-5.1452,-4.5124,-7.0252,-5.7571};

	
			
			
	prob=(exp(coef[index]*sp+constant[index])/(1+exp(coef[index]*sp+constant[index])));
	/*printf("coef:%f const:%f prob:%f dentro exp:%f exp:%f exp(1):%f\n",coef[index],constant[index],prob,
			coef[index]*sp+constant[index],exp(coef[index]*sp+constant[index]));
	return prob;

}
*/


void takeAdecision(float a[],struct CKB_env *clKB,float threshold[],short d[]) {
  int i,j;
  float rowMean;
  

  /*if(j==-3.2 &&  j==-25)printf("MA COME FAI A ENTRA' QUI");
	  && (j==25 || j==27))) 
		  || (clKB->numOfTermExp[j]>=3.8 && j==21))   {
		  	d[j]=1;
	  		printf("\nNum di Correzione efficaci %d",++n);
			}*/
  	       
  for (j=0; j<clKB->centroidNumber ; j++){
		/*TEST printf ("\n classe %d ha %f term exp",j,clKB->numOfTermExp[j]);*/					  
    #ifdef RDS
	   rowMean=0;
	   for (i=0 ; i<clKB->centroidNumber ; i++)
    		if(i!=j)rowMean+=(a[j]-a[i]);
     	  rowMean/=(clKB->centroidNumber - 1);
 
	  d[j]=0;
	  if(rowMean>=threshold[j])d[j]=1;
	 
    #endif	  
	   
  #ifdef SCUT 
	
	if(a[j]>= threshold[j])d[j]=1;
    	     else d[j]=0;
	
  #endif	     
    
    
    #ifdef COMBINED_SCUT_RDS
	if(j!=86 && j!=21){
	if(a[j]>= threshold[j])d[j]=1;
    	     else d[j]=0;}
	 else{ 
	 rowMean=0;   
	 for (i=0 ; i<clKB->centroidNumber ; i++)
    		if(i!=j)rowMean+=(a[j]-a[i]);
	 if(rowMean>=threshold[j])d[j]=1;
	 else d[j]=0;}
    #endif	     
    }
    
}    
    
	
/*void takeAdecisionRanking(float a[], struct CKB_env *clKB, float percentRank, short d[], float *remain) {
  
  int i,j,indMaxScore;
  float topRank,maxScore;
  
  indMaxScore=0;
  for(i=0; i<clKB->centroidNumber ; i++)d[i]=0;
  topRank=(((float)percentRank)+*remain);
  for (j=0; j<(int)topRank ; j++){
     maxScore=0;
     for(i=0; i<clKB->centroidNumber ; i++){
	 /*TESTprintf("\n*****prob. della classe %d: %f ---- sp:%f\n\n",i,prob(a[i],i),a[i]);    
    	if(maxScore<prob(a[i],i)&&d[i]!=1){maxScore=prob(a[i],i);indMaxScore=i;}
     }	
     d[indMaxScore]=1;        
  }
  *remain=topRank-((int)topRank);
}     
*/
		
			  
int computeNumberOfCorpusDoc(FILE *oracleFile)
{
 
 int numOfCorpusDoc=0;
 char class[MAX_CLASS_LENGHT];
 char idDoc[ID_DOC_LENGHT];
 char idDocOld[ID_DOC_LENGHT];
 
 fscanf(oracleFile,"%s",idDoc);
 (*idDocOld)='\0';
 while(!feof(oracleFile)){
      
      fscanf(oracleFile,"%s",class);
      if(strcmp(idDoc,idDocOld)!=0)numOfCorpusDoc++;
      strcpy(idDocOld,idDoc);
      fscanf(oracleFile,"%s",idDoc);
      
 }
 return numOfCorpusDoc;
}


int loadOracle(struct oracleCell **oracle, char oraclePath[PATH_LENGHT]) {
    
 int numOfCorpusDoc=0,cellIndex=0,
     classIndex,
     numOfClassPerDoc;
 char class[MAX_CLASS_LENGHT];
 char idDoc[ID_DOC_LENGHT];
 char idDocOld[ID_DOC_LENGHT];
 char classes[MAX_CLASS_NUMBER][MAX_CLASS_LENGHT];
 FILE *oracleFile;
 
   if((oracleFile = fopen(oraclePath,"r"))==NULL) {
		printf("Warning : file %s does not found\n",oraclePath);
		return 0;
     }
    else printf("\tfile %s opened\n",oraclePath);  	
 
   numOfCorpusDoc=computeNumberOfCorpusDoc(oracleFile);
   /*TEST printf ("Number of Doc = %d\n",numOfCorpusDoc);*/
   (*oracle) = (struct oracleCell *) malloc(numOfCorpusDoc * sizeof(struct oracleCell));
   rewind(oracleFile);
   
   fscanf(oracleFile,"%s",idDoc);
   /*TEST printf ("idDoc %s\n",idDoc);*/
   while(!feof(oracleFile)){
      strcpy((*oracle)[cellIndex].idDoc,idDoc);
      numOfClassPerDoc=0;
      strcpy(idDocOld,idDoc);	   
      while(!feof(oracleFile) && strcmp(idDoc,idDocOld)==0){
	      fscanf(oracleFile,"%s\n",class);
	      /*TEST printf ("class %s\n",class);*/
	      strcpy(classes[numOfClassPerDoc],class);
	      numOfClassPerDoc++;
	      fscanf(oracleFile,"%s",idDoc);
	      /*TEST printf ("idDoc %s\n",idDoc);*/
      }
      (*oracle)[cellIndex].targetClass=(char **)malloc((numOfClassPerDoc+1)*sizeof(char *));
      (*oracle)[cellIndex].targetClass[numOfClassPerDoc]=NULL;
      for(classIndex=0;classIndex<numOfClassPerDoc;classIndex++)
	  (*oracle)[cellIndex].targetClass[classIndex]=strdup(classes[classIndex]);
      cellIndex++;
   }
   /*TEST  printf ("stampa oracolo \n");
   for(cellIndex=0;cellIndex<numOfCorpusDoc;cellIndex++){
	    classIndex=0;
	    printf("Document id: %s belong to: ",(*oracle)[cellIndex].idDoc);
	    while((*oracle)[cellIndex].targetClass[classIndex]!=NULL){
		    printf("%s\t",(*oracle)[cellIndex].targetClass[classIndex]);
		    classIndex++;
	    }
	    printf("\n");
   }*/	    
	  
   fclose(oracleFile);
		   
   return numOfCorpusDoc;
}  
	    	
	

/*Performance Computation*/


void computeCellContigencyTable(struct contigencyCell *contigencyTable, char **oracleRow,
		                short *decision,struct CKB_env *clKB) {
int class,
    targetClass;	

	for(class=0;class<clKB->centroidNumber;class++){
	    targetClass=0;
 	    while(oracleRow[targetClass]!=NULL && 
		  strcasecmp(oracleRow[targetClass],clKB->centroidNames[class])!=0)
	    {
/*TEST	     printf("target %s != class
	     %s\n",oracleRow[targetClass],clKB->centroidNames[class]);
*/
	     targetClass++;}
	     
/*TEST	     if(decision[class]==1)printf("La classe %s e' stata selezionata\n",clKB->centroidNames[class]);
	     
	     if(oracleRow[targetClass]!=NULL)
		     printf("target %s = class %s\n",oracleRow[targetClass],clKB->centroidNames[class]);
	     else printf("la classe %s non fa parte dei topics\n",clKB->centroidNames[class]);
*/	  
	     if(decision[class]==1)
	    	  if(oracleRow[targetClass]==NULL)contigencyTable[class].wrong++;
	    	  else contigencyTable[class].correct++;
	      else if(oracleRow[targetClass]!=NULL)
	      {contigencyTable[class].notRecovered++;
/*TEST 	       if (class==2) printf("\n\n\n-->%s<--\n",oracleRow[targetClass]);*/}
/*TEST   
	 
	 printf("correct %d, wrong %d not retrieved %d",contigencyTable[class].correct,
			    contigencyTable[class].wrong,contigencyTable[class].notRecovered);
	 getchar();
*/	 


        }
}			

void computeRecallPrecison(struct contigencyCell *contigencyTable,
			   struct CKB_env *clKB,struct results *perClassPR) {
	
 int class,
     wrong=0,
     notRecovered=0,
     correct=0;
 
 float  macroAverageRecall=0,
	macroAveragePrecision=0,
	microAverageRecall,
	microAveragePrecision,
	classRec,
	classPrec;
 
  /* non fare parteciare al calcolo le seguenti classi */
  int j,flag;
  char classe[30][18]={"yen","veg-oil","soybean","soyoil","sorghum","ship","oilseed","meal-feed","stg",
		  "nat-gas","lead","ipi","heat","groundnut","gnp","crude","cpi","corn"};

 printf("\n\n");

 for(class=0;class<clKB->centroidNumber;class++){
	 flag=0;
  /*for(j=0;j<20;j++)
     if(strcmp(classe[j],clKB->centroidNames[class])==0)flag=1;*/
	 if(!flag){
	  printf("%d): %7s\tcorrect: %d\t wrong: %d\t not retrieved: %d\n",class,clKB->centroidNames[class],
		contigencyTable[class].correct,contigencyTable[class].wrong,
		contigencyTable[class].notRecovered);
	  wrong+=contigencyTable[class].wrong;
	  correct+=contigencyTable[class].correct;
	  notRecovered+=contigencyTable[class].notRecovered;}
	  
  }
  
 microAverageRecall=(float)correct/(float)(correct+notRecovered);
 microAveragePrecision=(float)correct/(float)(correct+wrong);
 
 printf("                   	         %d\t\t%d\t\t\t%d",correct,wrong,notRecovered);
 
 printf("\n\nMicroAverage:\tRecall: %f\tPrecision: %f\n",microAverageRecall,microAveragePrecision);
 printf("\n\n");
 
 for(class=0;class<clKB->centroidNumber;class++){
     if(contigencyTable[class].wrong+contigencyTable[class].notRecovered==0)
	     classRec=classPrec=1;      
     else{
	
	if(contigencyTable[class].notRecovered==0)classRec=1;
	else
	   classRec=((float)contigencyTable[class].correct)/((float)contigencyTable[class].correct+
	   				    (float)contigencyTable[class].notRecovered);
	   
	if(contigencyTable[class].wrong==0)classPrec=1; 
	else
	   classPrec=((float)contigencyTable[class].correct)/((float)contigencyTable[class].correct+
			   				    (float)contigencyTable[class].wrong);   		   										
     }
     printf("%d): %7s\tRecall: %f\tPrecision: %f\t difference: %f\n",class,clKB->centroidNames[class],
	     classRec,classPrec,(classRec-classPrec)*sgn(classRec-classPrec));
     perClassPR[class].precision=classPrec;
     perClassPR[class].recall=classRec;
     macroAverageRecall+=classRec;
     macroAveragePrecision+=classPrec;	
 }
	
 printf("\nMacroAverage:\tRecall: %f\tPrecision: %f\n\n",macroAverageRecall/clKB->centroidNumber,
		 				     macroAveragePrecision/clKB->centroidNumber);
}


void initContigencyTable(struct contigencyCell *contigencyTable,struct CKB_env *clKB) {
	
 int class;
 
	for(class=0;class<clKB->centroidNumber;class++)
		contigencyTable[class].correct=
		contigencyTable[class].notRecovered=
		contigencyTable[class].wrong=0;
}	


char *docClassName (char *docName,char *className)
{
 int i=0;
  
 while((docName[i]>'9' || docName[i]<'0')&& i<strlen(docName))
   className[i]=docName[i++];
 className[i]='\0';
 return className;
} 

void docClassNumber (char *docName,char *className)

{
 int i=0,numberStart=0;
 while((docName[i]>'9' || docName[i]<'0')&& i<strlen(docName))i++;
 numberStart=i;
 while((docName[i]<='9' && docName[i]>='0')&& i<strlen(docName))
   className[i-numberStart]=docName[i++];
 className[i-numberStart]='\0';
} 
 
int searchIdDoc(char *idDoc,struct oracleCell *oracle,int i, int j)
{
 if(i>j)return -1;
   else
    if(strcmp((char *)oracle[i+(j-i)/2].idDoc,idDoc)==0) return i+(j-i)/2;
      else 
       if(strcmp((char *)oracle[i+(j-i)/2].idDoc,idDoc)<0)
       	 return searchIdDoc(idDoc,oracle,i+(j-i)/2+1,j);
       else
       	 return searchIdDoc(idDoc,oracle,i,i+(j-i)/2-1);
 }  
  

 
  

int task5(struct classifier_env my_env, char *extension, float threshold[], 
		struct results *perClassPR)
{ 
  int whichDocument;
  int i;
  int r;
  
  char  documentAbsName[PATH_LENGHT];
  char  scalarProductsAbsName[PATH_LENGHT];
  char  NumericScalarProductsAbsName[PATH_LENGHT];
  char  className [PATH_LENGHT];
  struct CKB_env my_CKB_env;
  
  struct dictionary docCentroid[MAX_DOC_SIZE];
  int 	 centroidSize;
  
  FILE *scalarProductsFile;
  FILE *NumericScalarProductsFile;
  FILE *documentFile;
  

  float scalarProducts[MAX_CLASS_NUMBER];
  short decision[MAX_CLASS_NUMBER];
  
  struct oracleCell *oracle;
  struct contigencyCell contigencyTable[MAX_CLASS_NUMBER];
  
  int numOfCorpusDoc;
  char 	idDoc[PATH_LENGHT];
  int idDocPos;  
  float remain=0;

   
  /* -------------------------------------------- */
  /*    Load the classification Knowledge Bases   */
  /* -------------------------------------------- */

   loadClassificationKB(my_env,extension,&my_CKB_env);
    
  /* -------------------------------------------- */
  /*    Load the classification Knowledge Bases   */
  /* -------------------------------------------- */

   numOfCorpusDoc=loadOracle(&oracle,my_env.oracle_path);

  /* -------------------------------------------- */
  /*   Initialise Contigency Table	          */
  /* -------------------------------------------- */ 
  
   initContigencyTable(contigencyTable,&my_CKB_env);
  
  /* -------------------------------------------- */
  /* Open Scalar Products file and create Header  */
  /* -------------------------------------------- */
 
  sprintf(scalarProductsAbsName,"%s/%s_test.%s",my_env.output_path,SCALAR_PRODUCTS,"txt");
  if((scalarProductsFile = fopen(scalarProductsAbsName,"w"))==NULL) {
      if (my_env.verbose_switch==ON) printf("file %s write permission denied\n",scalarProductsAbsName);
      exit(-1);
  }
  
  sprintf(NumericScalarProductsAbsName,"%s/%s_test.number.%s",my_env.output_path,SCALAR_PRODUCTS,extension);
  if((NumericScalarProductsFile = fopen(NumericScalarProductsAbsName,"w"))==NULL) {
      if (my_env.verbose_switch==ON) printf("file %s write permission denied\n",NumericScalarProductsAbsName);
      exit(-1);
  }
  
		  
  for(i=0;i<my_CKB_env.centroidNumber;i++)
	  fprintf(NumericScalarProductsFile,"%14s",my_CKB_env.centroidNames[i]);
  fprintf(NumericScalarProductsFile,"\n");

  /* ---------------------------- */
  /* Classify a set of documents  */
  /* ---------------------------- */

  n=0;  
  for(whichDocument=0;whichDocument<my_env.document_number;whichDocument++) {

      
     sprintf(documentAbsName,"%s/%s.%s",my_env.test_doc_path,my_env.document_names[whichDocument],extension);
     if((documentFile = fopen(documentAbsName,"r"))==NULL) {
		printf("Warning : file %s does not found\n",documentAbsName);
		return 0;
     } 		
			       
     centroidSize=buildDocumentCentroid(documentFile,docCentroid,extension);
     
     fclose(documentFile);
	  
  
     if (my_env.verbose_switch==ON) printf ("\n  Classification of %s... ",documentAbsName);
  
     aDocumentScalarProduct(docCentroid,centroidSize,extension,&my_CKB_env,
     scalarProducts);

      if (my_env.verbose_switch==ON) printf ("done !\n"); 
     

     if (my_env.verbose_switch==ON) printf ("  Decision ... "); 
     
     /* Threshold POLICY */
     
     takeAdecision(scalarProducts,&my_CKB_env,threshold,decision);
     
     /* Ranking Policy document percentage
     
     remain=0;
     takeAdecisionRanking(scalarProducts,&my_CKB_env,1.2,decision,&remain);*/
          
     if (my_env.verbose_switch==ON) printf ("done !\n"); 

   
  /**** Compute Contigency Table ****/   
     
     strcpy(idDoc,"");
     docClassNumber(my_env.document_names[whichDocument],idDoc);
/*TEST		printf("\n\nIl doc <%s>  appartiene a:\n",idDoc);*/
/*TEST 		printf("seeking doc : %s\n",idDoc);
     if (my_env.verbose_switch==ON) printf ("  Contigency Cell ... "); */
     idDocPos=searchIdDoc(idDoc,oracle,0,numOfCorpusDoc-1);
/*TEST		 printf("document found in loc %d\n",idDocPos);*/
     if(idDocPos==-1)
	     printf("Warning: The Document %s is not present in the ORACLE; did you select a wrong ORACLE?\n",idDoc);
     else 
     computeCellContigencyTable(contigencyTable,oracle[idDocPos].targetClass,decision,&my_CKB_env);
     if (my_env.verbose_switch==ON) printf ("written !\n"); 
     

#ifdef     OUTPUT_STDSCARTI
              
     /*** Output of Classifier ***/
     if (my_env.verbose_switch==ON) printf ("  Writing output ... "); 

     fprintf(scalarProductsFile,"%s\t%s",
	docClassName(my_env.document_names[whichDocument],className),idDoc);
     fprintf(NumericScalarProductsFile,"%s\t",my_env.document_names[whichDocument]);

     for(i=0;i<my_CKB_env.centroidNumber;i++)fprintf(scalarProductsFile,"\t%d",decision[i]);      
 
     for(i=0;i<my_CKB_env.centroidNumber;i++)
   	  fprintf(NumericScalarProductsFile,"%14.10f",scalarProducts[i]);

     fprintf(NumericScalarProductsFile,"\n");
     fprintf(scalarProductsFile,"\n");

     if (my_env.verbose_switch==ON) printf ("done !\n"); 

#endif
     
  }
  /*close the Scalar Product file */
  fclose(scalarProductsFile);
  fclose(NumericScalarProductsFile);
  printf("\n%s %s written\n",scalarProductsAbsName,NumericScalarProductsAbsName);

  
  /*************/
  printf("\n%s %s written\n",scalarProductsAbsName,NumericScalarProductsAbsName);
  printf("\n\t\t\t\t\tRESULTS\n");
  computeRecallPrecison(contigencyTable,&my_CKB_env,perClassPR);
  
  /* Shutdown the Classification Knowledge Bases */
  shutdownClassificationKB(&my_CKB_env);
  shutdownOracle(oracle,numOfCorpusDoc);
  return my_CKB_env.centroidNumber;
}

 void Classification(struct classifier_env my_env) 
  {
   int i,
       classNumber,
       NumberOfClasses;
   float		   
	threshold[MAX_CLASS_NUMBER];
   float RP_Difference;
  
   float
	 MagThreshold[MAX_CLASS_NUMBER],
	 MinThreshold[MAX_CLASS_NUMBER];
/*	 
float MinThreshold[]={0.000000,0.015869,10000.000000,0.017090,0.024414,5.000000,0.009155,0.039062,0.053711,0.156250,0.021973,0.017930,0.000000,5.000000,0.004883,0.022278,0.106506,0.000687,0.312500,0.008545,0.039062,0.001640,5.000000,0.039062,0.039062,0.003436,0.039062,0.304565,0.019531,0.078125,0.048828,0.078125,0.029297,0.156250,0.000038,0.029297,0.023193,0.019888,2499.985352,0.014648,10000.000000,0.036621,0.078125,5.000000,0.008545,0.039062,0.006104,-0.000094,0.012207,0.156250,0.023193,0.039062,5.000000,0.014648,0.000038,0.058594,0.625000,0.019531,0.234375,0.016479,0.078125,0.126953,5.000000,0.156250,0.156250,5.000000,0.149536,0.031671,0.026855,0.039062,0.019531,0.024414,0.003591,0.040283,0.019531,0.012207,0.014648,0.002441,0.063477,0.019073,0.014648,0.031738,0.039062,5.000000,0.039062,0.039062,0.000086,0.004883,0.000916,5.000000,0.048828,0.025589,0.047694};
float MagThreshold[]={-0.000002,0.015259,0.039062,0.015869,0.021973,0.000000,0.008545,0.019531,0.048828,0.000000,0.019531,0.017930,0.000000,0.000000,0.002441,0.021973,0.068359,0.000610,0.000000,0.007935,0.019531,0.001602,0.000000,0.034180,0.000000,0.003436,0.019531,-0.000610,0.014648,0.000000,0.039062,0.039062,0.019531,0.117188,0.000000,0.019531,0.021973,0.019888,-0.019531,0.009766,0.039062,0.034180,0.039062,0.000000,0.007324,0.019531,0.004883,-0.000094,0.010986,0.000000,0.022583,0.019531,0.000000,0.009766,0.000000,0.039062,0.000000,0.009766,0.156250,0.016174,0.000000,0.117188,0.000000,0.000000,0.000000,0.000000,0.073242,0.031671,0.025635,0.019531,0.000000,0.019531,0.003591,0.039062,0.000000,0.009766,0.014038,0.000000,0.058594,0.000000,0.009766,0.029297,0.000000,0.000000,0.000000,0.029297,0.000076,0.002441,0.000763,0.000000,0.043945,0.025589,0.047694};
*/		
   struct results perClassPR[MAX_CLASS_NUMBER];
   short finish;
   int count;
   char  learningType[4];

      /* show the environment*/
   if (my_env.verbose_switch==ON) {
   printf("           dict_path = %s\n",my_env.dict_path);
   printf("         output_path = %s\n",my_env.output_path);
   printf("       test_doc_path = %s\n",my_env.test_doc_path);
   printf("            tmp_path = %s\n\n",my_env.tmp_path);
   
   printf("      verbose_switch = %s\n\n",(my_env.verbose_switch==ON?"ON":"OFF"));
   
   printf("           le_switch = %s\n",(my_env.le_switch==ON?"ON":"OFF"));
   printf("           ne_switch = %s\n",(my_env.ne_switch==ON?"ON":"OFF"));
   printf("           ev_switch = %s\n\n",(my_env.ev_switch==ON?"ON":"OFF"));
   
   printf("     document_number = %d\n\n",my_env.document_number);
   
   for (i=0; i<my_env.document_number ; i++)
     printf("     document_names[%d] = %s\n",i,my_env.document_names[i]);
   }
   
   if (my_env.le_switch==ON)strcpy(learningType,"le");
   if (my_env.ne_switch==ON)strcpy(learningType,"ne");
   if (my_env.ev_switch==ON)strcpy(learningType,"ev");
			   
			   
  for(i=0;i<MAX_CLASS_NUMBER;i++) {
	/**/MagThreshold[i]=-30;
	MinThreshold[i]=30;
	threshold[i]=(MagThreshold[i]+MinThreshold[i])/2;
  }
  
   
  finish=0;count=0;
  while(finish==0 && count < MAX_CICLE_NUMBER){
    finish=1;count++;	  
    NumberOfClasses=task5(my_env,learningType,threshold,perClassPR);
    for(classNumber=0;classNumber<NumberOfClasses;classNumber++){
	RP_Difference=(perClassPR[classNumber].recall-perClassPR[classNumber].precision);
	   if(RP_Difference*sgn(RP_Difference)>0.0001 || 
	      (perClassPR[classNumber].recall==perClassPR[classNumber].precision &&
			perClassPR[classNumber].recall==0)){
		if(RP_Difference>0)MagThreshold[classNumber]=threshold[classNumber];
		else MinThreshold[classNumber]=threshold[classNumber];
		if((count>MAX_CICLE_NUMBER-5 && perClassPR[classNumber].precision<.10))threshold[classNumber]=10000;   
	   	else{
		     threshold[classNumber]=(MinThreshold[classNumber]+MagThreshold[classNumber])/2;
	   	     finish=0;
	        } 
	   }
  }
  
    printf("\nMinThreshold[]={%f",MinThreshold[0]);
    for(classNumber=1;classNumber<NumberOfClasses;classNumber++)
	printf(",%f",MinThreshold[classNumber]);   
    printf("};\n");
    
    printf("\nMagThreshold[]={%f",MagThreshold[0]);
    for(classNumber=1;classNumber<NumberOfClasses;classNumber++)
	printf(",%f",MagThreshold[classNumber]);   
    printf("};\n");		
  }
} 
		

		
