/***********************************************************************/
/*   Text Categorization Framework                                     */
/*                                                                     */
/*                                                                     */
/*   Author: Alessandro Moschitti                                      */
/*   moschitti@info.uniroma2.it                                        */
/*   Date: 30.11.03                                                    */
/*                                                                     */
/*   Copyright (c) 2003  Alessandro Moschitti - All rights reserved    */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/



#include "classifier.h"
#include <math.h>

float terminologicalWeigth(char *term){
   int  i,
    	numberOfComponent=0;
   for(i=0;i<strlen(term);i++)
      if(term[i]=='_')numberOfComponent++;

   switch (numberOfComponent) {
	case 0: return 1;
	case 1: return 50;
	case 2: return 50;
	case 3: return  50;
	default: return 50;    
   }
  
}  	

/*

Con la nuova gestione Scut
case 0: return 2;
	case 1: return 16;
	case 2: return 4;
	case 3: return 4;
	default: return 4; 
	
	
Quello dell'articolo
 switch (numberOfComponent) {
	case 0: return 1;
	case 1: return 3;
	case 2: return 10;
	case 3: return 41;
	default: return 206;
   }


Base
switch (numberOfComponent) {
	case 0: return 1;
	case 1: return 1;
	case 2: return 1;
	case 3: return 1;
	default: return 1;
   }	

/*Best 

switch (numberOfComponent) {
	case 0: return 4;
	case 1: return 8;
	case 2: return 64;
	case 3: return 256;
	default: return 1024;
   }	
   
ultimo provato
switch (numberOfComponent) {
	case 0: return 6;
	case 1: return 12;
	case 2: return 36;
	case 3: return 72;
	default: return 240;
   }	
   
   Il Best TEORICO
   
   switch (numberOfComponent) {
	case 0: return 6;
	case 1: return 12;
	case 2: return 36;
	case 3: return 144;
	default: return 720;
   }	
   
 Best -o  
    switch (numberOfComponent) {
	case 0: return 1.1;
	case 1: return 1.2;
	case 2: return 1.3;
	case 3: return 1.5;
	default: return 2;
   }	
   
   
 Best teorico secondo Basili
  
		 
 switch (numberOfComponent) {
	case 0: return 6;
	case 1: return 18;
	case 2: return 61;
	case 3: return 246;
	default: return 1236;
   }
   
   */

float terminologicalWeigthOfOtherClass(char *term){
   int  i,
    	numberOfComponent=0;
   for(i=0;i<strlen(term);i++)
      if(term[i]=='_')numberOfComponent++;
   switch (numberOfComponent) {
	case 0: return 1;
	case 1: return 1;
	case 2: return 1;
	case 3: return 1;
	default: return 1;
   }	
   
}	
		 


void documentNormaComputation(struct classFiles class[],int classNumber,
		struct dictionaryOffset *globalCe, int numOfDoc, int differentTermNumber)
{
  int whichClass,
      freq,
      docID,
      termPos,
      i,
      docSize;
  
  char 
	documentId[TERM_LENGHT],
	documentIdOld[TERM_LENGHT],
      	term[TERM_LENGHT];
    
  float	IDF,tfi;
  
  for(whichClass=0;whichClass<classNumber;whichClass++){
     for(i=0;i<=(int)(class[whichClass].numOfDocuments*MAX_CHUNK_NUMBER);i++)
	     class[whichClass].Norma[i]=0;
     fscanf(class[whichClass].file,"%s",documentId);
     /*TEST*/ printf("class Number: %d\n",whichClass);
     while(!feof(class[whichClass].file)){
	 docID=hash(documentId);	     
	 strcpy(documentIdOld,documentId);
/*TEST printf("documentID: %s\n",documentId);*/
	 docSize=1;  
	 while(!feof(class[whichClass].file)&&strcmp(documentId,documentIdOld)==0){    
	      fscanf(class[whichClass].file,"%s",term);
	      fscanf(class[whichClass].file,"%d",&freq);
/*TEST   getchar();    printf("docID %d\tterm: %s\t freq: %d\n",docID,term,freq);*/
	          
	      tfi=ft(freq);termPos=0;
/* PER DARE + PESO ALLA TERM if((term[strlen(term)-4]=='-')&&(term[strlen(term)-3]=='t'))
	
	/*Same weight to all term with different size tfi*=4.3;
	       tfi*=terminologicalWeigth(term);*/
	
	      termPos=Search(globalCe,term,0,differentTermNumber-1);
/*TEST printf("\ntermine trovato alla posizione %d\n",termPos);*/
	      if(termPos<0){
	       printf("\tWarning:The term '%s' is not contained in global centroid\n",term);
	       printf("docID %d\tterm: %s\t freq: %d\n",docID,term,freq);
	      }
	      else{
		 IDF = log(((float) numOfDoc)/(float)globalCe[termPos].Offset);
		 /*!!!  mofifica senza IDF**IDF=1;*/
		 /*TEST printf("term:%s\t,pos %d freq %f DF %d \t IDF %f IDF*freq:%f\n",term,termPos,tfi,
				 globalCe[termPos].Offset,IDF,tfi*IDF);*/
		 class[whichClass].Norma[docID]+=(tfi*IDF*tfi*IDF);
		 docSize++;
	      }	 
		 fscanf(class[whichClass].file,"%s",documentId);
	     	 
	   
         }
	 class[whichClass].Norma[docID]=sqrt(class[whichClass].Norma[docID]);
	 /*TEST printf("document Norma:%f, DocSize:%d
			 docNumber:%s\n",class[whichClass].Norma[docID],docSize,documentIdOld);
	 getchar();*/


     }
  }
}  	  
  

task6(struct dict_env my_env, char *extension)
{  
 

 int isUpdated=1, 	/* is 1 if at least a term was written in Global Centroiod*/
     totalDocumentNumber2, /*the Number of Corpus terms with frequency included*/ 		 
     classNumber,
     totalDocumentNumber,
     i,j,n,
     pointer=0,
     differentWordNumber=0; /* when a term of type o is encountered the number of document which appears in is
     store here an is used for weighting the term of type t*/
    
 float	documentTermWeight,
	centroidMaxWeight=0,
	negativSumOfOther,
	gamma;
  
 char	term[TERM_LENGHT],
	dictAbsName[PATH_LENGHT],
	weightDictAbsName[PATH_LENGHT],
 	infoDictionariesAbsName[PATH_LENGHT],
	globalCentroidAbsName[PATH_LENGHT],
        orderedCentroidFileName[PATH_LENGHT];
  
 char   sortcommand[200];
 
 struct classFiles class[MAX_CLASS_NUMBER];
 
 struct dictionaryOffset *globalDF;
 	
 FILE 
	*dictWeightFile,
	*dictFile,
	*infoDictionariesFile,
	*globalCentroidFile;
		 
   
   sprintf(infoDictionariesAbsName,"%s/%s.%s",my_env.dict_path,INFO_DICTIONARY,extension);
   infoDictionariesFile = fopen(infoDictionariesAbsName,"w");   
   
   if(infoDictionariesFile==NULL){
      printf("ERROR: file %s write permission denied\n",infoDictionariesAbsName);
      exit(-1);
    }  
 
   sprintf(globalCentroidAbsName,"%s/%s.%s",my_env.global_centroid_path,GLOBAL_CENTROID,extension);
   globalCentroidFile=fopen(globalCentroidAbsName,"r");
   
   if(globalCentroidFile==NULL){
       printf("file %s does not found\n",globalCentroidAbsName);
       exit(-1);
     }
    
   totalDocumentNumber2=computeDifferentWordNumber(globalCentroidFile,my_env.verbose_switch,&differentWordNumber);
   totalDocumentNumber=computeTotalDocumentNumber(my_env,extension,class);
   fprintf(infoDictionariesFile,"Total_Document_Number= %d\nDifferent_Term_Number= %d\n",
   totalDocumentNumber,differentWordNumber);
      

   if (my_env.verbose_switch==ON) 
   	printf("\n\nBuild Dictionaries relative to %s infromation from centroids: \n\n",extension); 

   classNumber=openAllClasses(my_env.splitted_class_path,my_env.class_names,my_env.class_number,
		   my_env.verbose_switch,class,extension,infoDictionariesFile);
   
   if (my_env.verbose_switch==ON)     
      printf("file %s written\n",infoDictionariesAbsName);
   
   sprintf(dictAbsName,"%s/%s.%s",my_env.dict_path,OFFSET_DICTIONARY,extension);
   dictFile = fopen(dictAbsName,"w");   
   if(dictFile==NULL){
      printf("file %s write permission denied\n",dictAbsName);
      exit(-1);
    }
   
   sprintf(weightDictAbsName,"%s/%s.%s",my_env.dict_path,WEIGHT_DICTIONARY,extension);
   dictWeightFile = fopen(weightDictAbsName,"w");  
   if(dictWeightFile==NULL)
    {
      printf("file %s write permission denied\n",dictWeightFile);
      exit(-1);
    }
    
   fseek(globalCentroidFile, 0L, SEEK_SET);
   if (my_env.verbose_switch==ON)printf("Dictionary Loading\n");
   loadDictionaryOffset(globalCentroidFile, differentWordNumber, &globalDF);
   if (my_env.verbose_switch==ON)printf("Document Norma Computation\n");
   documentNormaComputation(class,classNumber,globalDF,totalDocumentNumber,differentWordNumber);
   if (my_env.verbose_switch==ON)printf("Classes' Status initialisation\n");
   initStatusOfClasses(class,classNumber);
   if (my_env.verbose_switch==ON)printf("Dictionary Weights building\n");
   isUpdated=1;
   gamma = atof(my_env.gamma);
   while(isUpdated){
      isUpdated=0;
     /* TEST printf("1\n");*/
      takeNextTermFromClasses(class,classNumber,totalDocumentNumber,globalDF,differentWordNumber);
     /* TEST printf("2\n"); */
      findMinTermOfClasses(class,classNumber);    
     /* TEST printf("3\n"); */
      isUpdated=writeCouplesOnDictionaryWeight
(dictWeightFile,dictFile,class,classNumber,totalDocumentNumber,&pointer,&negativSumOfOther,term,gamma);
     /* printf("4\n");*/
     }
     
   fclose(dictFile);
   fclose(dictWeightFile);
   
   if (my_env.verbose_switch==ON) 
   {
    printf("\n%s written\n",dictAbsName);
    printf("\n%s written\n",weightDictAbsName);
   }
   fprintf(infoDictionariesFile,"Max_Weight= %f\n",centroidMaxWeight);   
   closeAllClassFiles(class,classNumber,infoDictionariesFile);
   
   fclose(infoDictionariesFile);   
   shutdownDictionary(globalDF,differentWordNumber);
   thresholdComputation(my_env, extension);
}  
        


void DictionariesBuilding(struct dict_env my_env) 
{
   if (my_env.verbose_switch==ON) {
   int i;
   
   /* show the environment */
   printf("global_centroid_path = %s\n\n",my_env.global_centroid_path);
   printf("           dict_path = %s\n\n",my_env.dict_path);
   printf("            tmp_path = %s\n\n",my_env.tmp_path);
   
   printf("      verbose_switch = %s\n\n",(my_env.verbose_switch==ON?"ON":"OFF"));
   
   printf("           le_switch = %s\n",(my_env.le_switch==ON?"ON":"OFF"));
   printf("           ne_switch = %s\n",(my_env.ne_switch==ON?"ON":"OFF"));
   printf("           ev_switch = %s\n\n",(my_env.ev_switch==ON?"ON":"OFF"));
   
   printf("     centroid_number = %d\n\n",my_env.centroid_number);
   printf("     insert gamma = %s\n\n",my_env.gamma);
   
   for (i=0; i<my_env.centroid_number ; i++)
     printf("     centroid_names[%d] = %s\n",i,my_env.centroid_names[i]);
   }
   if (my_env.le_switch==ON)
      task6(my_env,"le");
   if (my_env.ne_switch==ON)
      task6(my_env,"ne");
   if (my_env.ev_switch==ON)
      task6(my_env,"ev");
}  
    
            
